var D = Object.defineProperty;
var M = (h, e, t) => e in h ? D(h, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : h[e] = t;
var c = (h, e, t) => (M(h, typeof e != "symbol" ? e + "" : e, t), t);
import { _ as l, a as v, N as T, R as $ } from "./utils-e497ad9b.js";
import { b as R, W as U } from "./services-b1c6f11d.js";
import "vue";
class s {
  constructor(e, t, r) {
    c(this, "partialUrl");
    c(this, "isPublic");
    c(this, "includeAuthHeader");
    c(this, "selectColumns");
    c(this, "searchParams");
    c(this, "paginationOptions");
    this.partialUrl = e, this.isPublic = t, this.includeAuthHeader = r;
  }
  url(e) {
    this.searchParams ?? (this.searchParams = []);
    const t = `${this.isPublic ? e.api_url_public : e.api_url_private}`, r = [
      this.selectColumns !== void 0 && this.selectColumns.length > 0 ? `select=${this.selectColumns.join(",")}` : ""
    ], n = [];
    this.paginationOptions && (n.push(`order=${this.paginationOptions.Order}.${this.paginationOptions.Sort}`), n.push(`limit=${this.paginationOptions.Limit}`), n.push(`offset=${this.paginationOptions.Offset}`));
    const o = [...r, ...this.searchParams, ...n].filter((a) => a).join("&");
    return o.length > 0 ? `${t}/${this.partialUrl}?${o}` : `${t}/${this.partialUrl}`;
  }
}
const i = class i {
  constructor() {
    c(this, "BOM", "\uFEFF");
    c(this, "options", {});
  }
  static get Instance() {
    return this._instance || (this._instance = new this()), this._instance;
  }
  isUser() {
    var e;
    return ((e = i._instance.options) == null ? void 0 : e.authStore.accessToken) !== void 0;
  }
  async initHeader(e, t, r) {
    var o;
    const n = {
      Accept: t.accept
    };
    return r == null || r.forEach((a) => {
      n[a.key] = a.value;
    }), (o = i._instance.options) != null && o.authStore.accessToken && (e.includeAuthHeader && (n.Authorization = `Bearer ${i._instance.options.authStore.accessToken}`), t.countType ? n.Prefer = `count=${t.countType}` : t.returnType && (n.Prefer = `return=${t.returnType}`), t.hash && (n.hash = t.hash)), n;
  }
  sanitizePayload(e) {
    const t = { ...e };
    return Object.keys(t).forEach((r) => {
      r.indexOf("_") === 0 && delete t[r];
    }), t;
  }
  export(e, t, r = l.CSV, n) {
    switch (r) {
      case l.JSON: {
        t = JSON.stringify(t);
        break;
      }
      default:
      case l.CSV: {
        const u = new URL(e).searchParams.get("select");
        if (u) {
          const g = t.split(`
`);
          g[0] = u.split(",").map((p) => p = p.split(":")[0] ?? "").join(","), t = `${this.BOM}${g.join(`
`)}`;
        }
        break;
      }
    }
    const o = new Blob([t], { type: r }), a = document.createElement("a");
    a.href = URL.createObjectURL(o), a.download = n ?? "export", a.click(), URL.revokeObjectURL(a.href);
  }
  configureApiServiceOptions(e) {
    i._instance.options = e;
  }
  async getPagedCollectionFromCacheOrDb(e, t = null, r = l.JSON, n, o = !1, a) {
    if (!this.isUser())
      return {
        totalRows: 0
      };
    const u = await R, g = `${t ? `${e.url(i._instance.options)}?${JSON.stringify(t)}` : e.url(i._instance.options)}_${r}`;
    let p = await u.getCacheItem(g);
    const O = (p == null ? void 0 : p.hash) || "", y = {
      accept: r,
      hash: O
    };
    e.paginationOptions && (y.countType = T.Exact);
    const S = await this.initHeader(e, y, n);
    try {
      const w = await i._instance.options.axiosInstance.post(
        e.url(i._instance.options),
        t,
        {
          headers: S
        }
      );
      if (w.status === 200) {
        O.length > 0 && await u.deleteCacheItem(g);
        const P = w.headers.hash, m = new U(P, w.data);
        await u.insertCacheItem(g, m), p = m;
      }
      let f = (p == null ? void 0 : p.data) ?? [];
      const d = (f == null ? void 0 : f.length) ?? 0;
      return o && this.export(e.url(i._instance.options), f, r, a), r === l.CSV ? {
        totalRows: d,
        exportData: `${this.BOM}${f}`,
        error: null
      } : (e.paginationOptions && (f = v(f, e.paginationOptions.Order, e.paginationOptions.Sort), e.paginationOptions.Offset && e.paginationOptions.Limit && (f = f.slice(
        e.paginationOptions.Offset,
        e.paginationOptions.Offset + e.paginationOptions.Limit
      ))), {
        totalRows: d,
        data: f,
        error: null
      });
    } catch (w) {
      return {
        totalRows: 0,
        error: w
      };
    }
  }
  async exportPagedCollectionFromCacheOrDb(e, t, r = l.CSV, n) {
    return await this.getPagedCollectionFromCacheOrDb(
      e,
      void 0,
      r,
      n,
      !0,
      t
    );
  }
  async getPagedCollection(e, t = l.JSON, r, n = !1, o) {
    if (!this.isUser() && !e.isPublic)
      return {
        totalRows: 0
      };
    try {
      const a = await this._getCollectionResponse(e, t, r);
      if (!a)
        return {
          totalRows: 0
        };
      const u = a.data ?? [], g = parseInt(a.headers["content-range"].split("/")[1]);
      return n && this.export(e.url(i._instance.options), u, t, o), t === l.CSV ? {
        totalRows: g,
        exportData: `${this.BOM}${u}`,
        error: null
      } : {
        totalRows: g,
        data: u,
        error: null
      };
    } catch (a) {
      return {
        totalRows: 0,
        error: a
      };
    }
  }
  async exportPagedCollection(e, t, r = l.CSV, n) {
    return await this.getPagedCollection(e, r, n, !0, t);
  }
  async getPagedCollectionByPost(e, t = null, r = l.JSON, n, o = !1, a) {
    if (!this.isUser())
      return {
        totalRows: 0
      };
    try {
      const u = await this.getCollectionByPost(e, t, r, n), g = (u == null ? void 0 : u.length) ?? 0, p = u ?? [];
      return o && this.export(e.url(i._instance.options), p, r, a), r === l.CSV ? {
        totalRows: g,
        exportData: `${this.BOM}${p}`,
        error: null
      } : {
        totalRows: g,
        data: p,
        error: null
      };
    } catch (u) {
      return {
        totalRows: 0,
        error: u
      };
    }
  }
  async _getCollectionResponse(e, t = l.JSON, r) {
    const n = {
      accept: t
    };
    e.paginationOptions && (n.countType = T.Exact);
    const o = await this.initHeader(e, n, r);
    return o ? await i._instance.options.axiosInstance.get(
      e.url(i._instance.options),
      {
        headers: o
      }
    ) : null;
  }
  async getCollection(e, t = l.JSON, r) {
    if (!this.isUser() && !e.isPublic)
      return [];
    try {
      const n = await this._getCollectionResponse(e, t, r);
      return (n == null ? void 0 : n.data) ?? [];
    } catch {
      return [];
    }
  }
  async getCollectionByPost(e, t, r = l.JSON, n) {
    if (!this.isUser())
      return [];
    const o = {
      accept: r,
      returnType: $.Representation
    }, a = await this.initHeader(e, o, n);
    if (!a)
      return [];
    try {
      return (t ? await i._instance.options.axiosInstance.post(
        e.url(i._instance.options),
        t,
        {
          headers: a
        }
      ) : await i._instance.options.axiosInstance.post(
        e.url(i._instance.options),
        { headers: a }
      )).data;
    } catch {
      return [];
    }
  }
  async getSingle(e, t) {
    if (!this.isUser())
      return {};
    const r = {
      accept: l.JSON
    }, n = await this.initHeader(e, r, t);
    if (!n)
      return {};
    try {
      const a = (await i._instance.options.axiosInstance.get(
        e.url(i._instance.options),
        {
          headers: n
        }
      )).data;
      return a != null && a.length && a.length > 0 ? a[0] : null;
    } catch {
      return null;
    }
  }
  async post(e, t, r, n) {
    t = this.sanitizePayload(t);
    const o = {
      accept: l.JSON,
      returnType: r
    }, a = await this.initHeader(e, o, n);
    return await i._instance.options.axiosInstance.post(
      e.url(i._instance.options),
      t,
      {
        headers: a
      }
    );
  }
  async put(e, t, r, n) {
    t = this.sanitizePayload(t);
    const o = {
      accept: l.JSON,
      returnType: r
    }, a = await this.initHeader(e, o, n);
    return await i._instance.options.axiosInstance.put(
      e.url(i._instance.options),
      t,
      {
        headers: a
      }
    );
  }
  async patch(e, t, r, n) {
    t = this.sanitizePayload(t);
    const o = {
      accept: l.JSON,
      returnType: r
    }, a = await this.initHeader(e, o, n);
    return await i._instance.options.axiosInstance.patch(
      e.url(i._instance.options),
      t,
      {
        headers: a
      }
    );
  }
  async delete(e, t) {
    const r = {
      accept: l.JSON
    }, n = await this.initHeader(e, r, t);
    try {
      return (await i._instance.options.axiosInstance.delete(
        e.url(i._instance.options),
        {
          headers: n
        }
      )).status;
    } catch {
      return 500;
    }
  }
};
c(i, "_instance");
let C = i;
const N = C.Instance;
class I {
}
c(I, "AUTH", {
  get Register() {
    return new s("rpc/register", !0, !1);
  },
  get Login() {
    return new s("rpc/login", !0, !1);
  }
}), c(I, "INVENTORY", {
  get Get() {
    return new s("Inventory", !1, !0);
  },
  get GetItemModels() {
    return new s("InventoryItemModels", !1, !0);
  },
  get PostItemModel() {
    return new s("InventoryItemModels", !1, !0);
  },
  get PatchItemModel() {
    return new s("InventoryItemModels", !1, !0);
  },
  get DeleteItemModel() {
    return new s("InventoryItemModels", !1, !0);
  },
  get GetDiskTypes() {
    return new s("InventoryDiskTypes", !1, !0);
  },
  get PostDiskType() {
    return new s("InventoryDiskTypes", !1, !0);
  },
  get PatchDiskType() {
    return new s("InventoryDiskTypes", !1, !0);
  },
  get DeleteDiskType() {
    return new s("InventoryDiskTypes", !1, !0);
  },
  get GetItemTypes() {
    return new s("InventoryItemTypes", !1, !0);
  },
  get PostItemType() {
    return new s("InventoryItemTypes", !1, !0);
  },
  get PatchItemType() {
    return new s("InventoryItemTypes", !1, !0);
  },
  get DeleteItemType() {
    return new s("InventoryItemTypes", !1, !0);
  },
  get GetModelMappings() {
    return new s("InventoryModelMappings", !1, !0);
  },
  get PostModelMappings() {
    return new s("InventoryModelMappings", !1, !0);
  },
  get PatchModelMappings() {
    return new s("InventoryModelMappings", !1, !0);
  },
  get DeleteModelMappings() {
    return new s("InventoryModelMappings", !1, !0);
  },
  get GetClientDiscounts() {
    return new s("InventoryClientDiscounts", !1, !0);
  },
  get PostClientDiscount() {
    return new s("InventoryClientDiscounts", !1, !0);
  },
  get PatchClientDiscount() {
    return new s("InventoryClientDiscounts", !1, !0);
  },
  get DeleteClientDiscount() {
    return new s("InventoryClientDiscounts", !1, !0);
  }
}), c(I, "OFFERS", {
  get Get() {
    return new s("ServerOffers", !0, !1);
  },
  get Post() {
    return new s("ServerOffers", !0, !0);
  },
  get Patch() {
    return new s("ServerOffers", !0, !0);
  },
  get Delete() {
    return new s("ServerOffers", !0, !0);
  },
  get GetTags() {
    return new s("ServerOfferTags", !0, !1);
  },
  get PostTags() {
    return new s("ServerOfferTags", !0, !0);
  },
  get DeleteTags() {
    return new s("ServerOfferTags", !0, !0);
  }
}), c(I, "ORDERS", {
  get Get() {
    return new s("ServerOrders", !1, !0);
  },
  get GetStatuses() {
    return new s("ServerOrderStatuses", !1, !1);
  },
  get Create() {
    return new s("rpc/CreateOrder", !1, !0);
  },
  get Update() {
    return new s("rpc/UpdateOrder", !1, !0);
  },
  get Delete() {
    return new s("rpc/DeleteOrder", !0, !1);
  },
  get DeleteOrderItem() {
    return new s("rpc/DeleteOrderItem", !0, !1);
  },
  get UpdateOrderItem() {
    return new s("rpc/UpdateOrderItem", !0, !0);
  },
  get CreateOrderEntry() {
    return new s("rpc/CreateOrderEntry", !0, !1);
  }
}), c(I, "CLIENT_PRODUCTS", {
  get Get() {
    return new s("ClientProducts", !1, !0);
  },
  get Post() {
    return new s("ClientProducts", !1, !0);
  },
  get Patch() {
    return new s("ClientProducts", !1, !0);
  }
}), c(I, "CLUSTER", {
  get GetVMs() {
    return new s("ClusterVMs", !1, !0);
  },
  get GetIps() {
    return new s("ClusterIps", !1, !0);
  },
  get PostIp() {
    return new s("ClusterIps", !1, !0);
  },
  get PatchIp() {
    return new s("ClusterIps", !1, !0);
  },
  get DeleteIp() {
    return new s("ClusterIps", !1, !0);
  },
  get GetIpsets() {
    return new s("ClusterIpsets", !1, !0);
  },
  get PostIpset() {
    return new s("ClusterIpsets", !1, !0);
  },
  get PatchIpset() {
    return new s("ClusterIpsets", !1, !0);
  },
  get DeleteIpset() {
    return new s("ClusterIpsets", !1, !0);
  },
  get GetIpsetsIps() {
    return new s("ClusterIpsetsIps", !1, !0);
  },
  get PostIpsetsIp() {
    return new s("ClusterIpsetsIps", !1, !0);
  },
  get PatchIpsetsIp() {
    return new s("ClusterIpsetsIps", !1, !0);
  },
  get DeleteIpsetsIp() {
    return new s("ClusterIpsetsIps", !1, !0);
  },
  get GetIpsetsVms() {
    return new s("ClusterIpsetsVms", !1, !0);
  },
  get PostIpsetsVm() {
    return new s("ClusterIpsetsVms", !1, !0);
  },
  get PatchIpsetsVm() {
    return new s("ClusterIpsetsVms", !1, !0);
  },
  get DeleteIpsetsVm() {
    return new s("ClusterIpsetsVms", !1, !0);
  },
  get PostToggleLockVM() {
    return new s("rpc/ClusterToggleLockVM", !1, !0);
  },
  get AddIPArrayToIPSet() {
    return new s("rpc/AddIPArrayToIPSet", !1, !0);
  }
});
export {
  N as ApiService,
  I as ApiServiceEndpoints
};
