import { Pinia } from 'pinia';
import { PrimeVueChangeTheme, PrimeVueConfiguration } from 'primevue/config';
import { ToastServiceMethods } from 'primevue/toastservice';
import { PropType } from 'vue';
import { RouteLocationNormalizedLoaded, Router } from 'vue-router';
declare const _default: import("vue").DefineComponent<{
    envMode: {
        type: StringConstructor;
        required: true;
    };
    portalBaseUrl: {
        type: StringConstructor;
        required: false;
    };
    loginBaseUrl: {
        type: StringConstructor;
        required: false;
    };
    router: {
        type: PropType<Router>;
        required: true;
    };
    route: {
        type: PropType<RouteLocationNormalizedLoaded>;
        required: true;
    };
    piniaInstance: {
        type: PropType<Pinia>;
        required: true;
    };
    primevue: {
        type: PropType<{
            config: PrimeVueConfiguration;
            changeTheme: PrimeVueChangeTheme;
        }>;
        required: true;
    };
    toast: {
        type: PropType<ToastServiceMethods>;
        required: true;
    };
}, {}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "sign-out": () => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    envMode: {
        type: StringConstructor;
        required: true;
    };
    portalBaseUrl: {
        type: StringConstructor;
        required: false;
    };
    loginBaseUrl: {
        type: StringConstructor;
        required: false;
    };
    router: {
        type: PropType<Router>;
        required: true;
    };
    route: {
        type: PropType<RouteLocationNormalizedLoaded>;
        required: true;
    };
    piniaInstance: {
        type: PropType<Pinia>;
        required: true;
    };
    primevue: {
        type: PropType<{
            config: PrimeVueConfiguration;
            changeTheme: PrimeVueChangeTheme;
        }>;
        required: true;
    };
    toast: {
        type: PropType<ToastServiceMethods>;
        required: true;
    };
}>> & {
    "onSign-out"?: (() => any) | undefined;
}, {}, {}>;
export default _default;
