import { unref as l } from "vue";
function R(e, t) {
  var r = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var a = Object.getOwnPropertySymbols(e);
    t && (a = a.filter(function(n) {
      return Object.getOwnPropertyDescriptor(e, n).enumerable;
    })), r.push.apply(r, a);
  }
  return r;
}
function v(e) {
  for (var t = 1; t < arguments.length; t++) {
    var r = arguments[t] != null ? arguments[t] : {};
    t % 2 ? R(Object(r), !0).forEach(function(a) {
      ee(e, a, r[a]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(r)) : R(Object(r)).forEach(function(a) {
      Object.defineProperty(e, a, Object.getOwnPropertyDescriptor(r, a));
    });
  }
  return e;
}
function ee(e, t, r) {
  return t in e ? Object.defineProperty(e, t, {
    value: r,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : e[t] = r, e;
}
function y(e) {
  return typeof e == "function";
}
function I(e) {
  return e !== null && typeof e == "object" && !Array.isArray(e);
}
function D(e) {
  return y(e.$validator) ? v({}, e) : {
    $validator: e
  };
}
function te(e) {
  return I(e) && y(e.then);
}
function $(e) {
  return typeof e == "object" ? e.$valid : e;
}
function h(e) {
  return e.$validator || e;
}
function V(e, t) {
  if (!I(e))
    throw new Error(`[@vuelidate/validators]: First parameter to "withParams" should be an object, provided ${typeof e}`);
  if (!I(t) && !y(t))
    throw new Error("[@vuelidate/validators]: Validator must be a function or object with $validator parameter");
  const r = D(t);
  return r.$params = v(v({}, r.$params || {}), e), r;
}
function b(e, t) {
  if (!y(e) && typeof l(e) != "string")
    throw new Error(`[@vuelidate/validators]: First parameter to "withMessage" should be string or a function returning a string, provided ${typeof e}`);
  if (!I(t) && !y(t))
    throw new Error("[@vuelidate/validators]: Validator must be a function or object with $validator parameter");
  const r = D(t);
  return r.$message = e, r;
}
function re(e) {
  let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : [];
  const r = D(e);
  return v(v({}, r), {}, {
    $async: !0,
    $watchTargets: t
  });
}
function ae(e) {
  return {
    $validator(t) {
      for (var r = arguments.length, a = new Array(r > 1 ? r - 1 : 0), n = 1; n < r; n++)
        a[n - 1] = arguments[n];
      return l(t).reduce((s, o, c) => {
        const i = Object.entries(o).reduce((u, Q) => {
          let [x, A] = Q;
          const X = e[x] || {}, S = Object.entries(X).reduce((m, Y) => {
            let [N, k] = Y;
            const w = h(k).call(this, A, o, c, ...a), T = $(w);
            if (m.$data[N] = w, m.$data.$invalid = !T || !!m.$data.$invalid, m.$data.$error = m.$data.$invalid, !T) {
              let O = k.$message || "";
              const q = k.$params || {};
              typeof O == "function" && (O = O({
                $pending: !1,
                $invalid: !T,
                $params: q,
                $model: A,
                $response: w
              })), m.$errors.push({
                $property: x,
                $message: O,
                $params: q,
                $response: w,
                $model: A,
                $pending: !1,
                $validator: N
              });
            }
            return {
              $valid: m.$valid && T,
              $data: m.$data,
              $errors: m.$errors
            };
          }, {
            $valid: !0,
            $data: {},
            $errors: []
          });
          return u.$data[x] = S.$data, u.$errors[x] = S.$errors, {
            $valid: u.$valid && S.$valid,
            $data: u.$data,
            $errors: u.$errors
          };
        }, {
          $valid: !0,
          $data: {},
          $errors: {}
        });
        return {
          $valid: s.$valid && i.$valid,
          $data: s.$data.concat(i.$data),
          $errors: s.$errors.concat(i.$errors)
        };
      }, {
        $valid: !0,
        $data: [],
        $errors: []
      });
    },
    $message: (t) => {
      let {
        $response: r
      } = t;
      return r ? r.$errors.map((a) => Object.values(a).map((n) => n.map((s) => s.$message)).reduce((n, s) => n.concat(s), [])) : [];
    }
  };
}
const d = (e) => {
  if (e = l(e), Array.isArray(e))
    return !!e.length;
  if (e == null)
    return !1;
  if (e === !1)
    return !0;
  if (e instanceof Date)
    return !isNaN(e.getTime());
  if (typeof e == "object") {
    for (let t in e)
      return !0;
    return !1;
  }
  return !!String(e).length;
}, z = (e) => (e = l(e), Array.isArray(e) ? e.length : typeof e == "object" ? Object.keys(e).length : String(e).length);
function f() {
  for (var e = arguments.length, t = new Array(e), r = 0; r < e; r++)
    t[r] = arguments[r];
  return (a) => (a = l(a), !d(a) || t.every((n) => (n.lastIndex = 0, n.test(a))));
}
var ne = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  forEach: ae,
  len: z,
  normalizeValidatorObject: D,
  regex: f,
  req: d,
  unwrap: l,
  unwrapNormalizedValidator: h,
  unwrapValidatorResponse: $,
  withAsync: re,
  withMessage: b,
  withParams: V
}), se = f(/^[a-zA-Z]*$/), oe = {
  $validator: se,
  $message: "The value is not alphabetical",
  $params: {
    type: "alpha"
  }
}, ie = f(/^[a-zA-Z0-9]*$/), ue = {
  $validator: ie,
  $message: "The value must be alpha-numeric",
  $params: {
    type: "alphaNum"
  }
}, ce = f(/^\d*(\.\d+)?$/), le = {
  $validator: ce,
  $message: "Value must be numeric",
  $params: {
    type: "numeric"
  }
};
function de(e, t) {
  return (r) => !d(r) || (!/\s/.test(r) || r instanceof Date) && +l(e) <= +r && +l(t) >= +r;
}
function me(e, t) {
  return {
    $validator: de(e, t),
    $message: (r) => {
      let {
        $params: a
      } = r;
      return `The value must be between ${a.min} and ${a.max}`;
    },
    $params: {
      min: e,
      max: t,
      type: "between"
    }
  };
}
const pe = /^(?:[A-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[A-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9]{2,}(?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])$/i;
var $e = f(pe), fe = {
  $validator: $e,
  $message: "Value is not a valid email address",
  $params: {
    type: "email"
  }
};
function ge(e) {
  if (!d(e))
    return !0;
  if (typeof e != "string")
    return !1;
  const t = e.split(".");
  return t.length === 4 && t.every(he);
}
const he = (e) => {
  if (e.length > 3 || e.length === 0 || e[0] === "0" && e !== "0" || !e.match(/^\d+$/))
    return !1;
  const t = +e | 0;
  return t >= 0 && t <= 255;
};
var ve = {
  $validator: ge,
  $message: "The value is not a valid IP address",
  $params: {
    type: "ipAddress"
  }
};
function ye() {
  let e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : ":";
  return (t) => {
    if (e = l(e), !d(t))
      return !0;
    if (typeof t != "string")
      return !1;
    const r = typeof e == "string" && e !== "" ? t.split(e) : t.length === 12 || t.length === 16 ? t.match(/.{2}/g) : null;
    return r !== null && (r.length === 6 || r.length === 8) && r.every(be);
  };
}
const be = (e) => e.toLowerCase().match(/^[0-9a-f]{2}$/);
function xe(e) {
  return {
    $validator: ye(e),
    $message: "The value is not a valid MAC Address",
    $params: {
      type: "macAddress"
    }
  };
}
function we(e) {
  return (t) => !d(t) || z(t) <= l(e);
}
function Te(e) {
  return {
    $validator: we(e),
    $message: (t) => {
      let {
        $params: r
      } = t;
      return `The maximum length allowed is ${r.max}`;
    },
    $params: {
      max: e,
      type: "maxLength"
    }
  };
}
function Oe(e) {
  return (t) => !d(t) || z(t) >= l(e);
}
function je(e) {
  return {
    $validator: Oe(e),
    $message: (t) => {
      let {
        $params: r
      } = t;
      return `This field should be at least ${r.min} characters long`;
    },
    $params: {
      min: e,
      type: "minLength"
    }
  };
}
function Ie(e) {
  return typeof e == "string" && (e = e.trim()), d(e);
}
var De = {
  $validator: Ie,
  $message: "Value is required",
  $params: {
    type: "required"
  }
};
const U = (e, t) => e ? d(typeof t == "string" ? t.trim() : t) : !0;
function Ae(e) {
  return function(t, r) {
    if (typeof e != "function")
      return U(l(e), t);
    const a = e.call(this, t, r);
    return U(a, t);
  };
}
function Se(e) {
  return {
    $validator: Ae(e),
    $message: "The value is required",
    $params: {
      type: "requiredIf",
      prop: e
    }
  };
}
const F = (e, t) => e ? !0 : d(typeof t == "string" ? t.trim() : t);
function ke(e) {
  return function(t, r) {
    if (typeof e != "function")
      return F(l(e), t);
    const a = e.call(this, t, r);
    return F(a, t);
  };
}
function Ee(e) {
  return {
    $validator: ke(e),
    $message: "The value is required",
    $params: {
      type: "requiredUnless",
      prop: e
    }
  };
}
function Pe(e) {
  return (t) => l(t) === l(e);
}
function Ce(e) {
  let t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "other";
  return {
    $validator: Pe(e),
    $message: (r) => `The value must be equal to the ${t} value`,
    $params: {
      equalTo: e,
      otherName: t,
      type: "sameAs"
    }
  };
}
const Be = /^(?:(?:(?:https?|ftp):)?\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z0-9\u00a1-\uffff][a-z0-9\u00a1-\uffff_-]{0,62})?[a-z0-9\u00a1-\uffff]\.)+(?:[a-z\u00a1-\uffff]{2,}\.?))(?::\d{2,5})?(?:[/?#]\S*)?$/i;
var Le = f(Be), _e = {
  $validator: Le,
  $message: "The value is not a valid URL address",
  $params: {
    type: "url"
  }
};
function Ve(e) {
  return function() {
    for (var t = arguments.length, r = new Array(t), a = 0; a < t; a++)
      r[a] = arguments[a];
    return e.reduce((n, s) => $(n) ? n : h(s).apply(this, r), !1);
  };
}
function ze(e) {
  return function() {
    for (var t = arguments.length, r = new Array(t), a = 0; a < t; a++)
      r[a] = arguments[a];
    return e.reduce(async (n, s) => {
      const o = await n;
      return $(o) ? o : h(s).apply(this, r);
    }, Promise.resolve(!1));
  };
}
function Me() {
  for (var e = arguments.length, t = new Array(e), r = 0; r < e; r++)
    t[r] = arguments[r];
  const a = t.some((o) => o.$async), n = t.reduce((o, c) => c.$watchTargets ? o.concat(c.$watchTargets) : o, []);
  let s = () => !1;
  return t.length && (s = a ? ze(t) : Ve(t)), {
    $async: a,
    $validator: s,
    $watchTargets: n
  };
}
function Ne() {
  return V({
    type: "or"
  }, b("The value does not match any of the provided validators", Me(...arguments)));
}
function qe(e) {
  return function() {
    for (var t = arguments.length, r = new Array(t), a = 0; a < t; a++)
      r[a] = arguments[a];
    return e.reduce((n, s) => $(n) ? h(s).apply(this, r) : n, !0);
  };
}
function Re(e) {
  return function() {
    for (var t = arguments.length, r = new Array(t), a = 0; a < t; a++)
      r[a] = arguments[a];
    return e.reduce(async (n, s) => {
      const o = await n;
      return $(o) ? h(s).apply(this, r) : o;
    }, Promise.resolve(!0));
  };
}
function Ue() {
  for (var e = arguments.length, t = new Array(e), r = 0; r < e; r++)
    t[r] = arguments[r];
  const a = t.some((o) => o.$async), n = t.reduce((o, c) => c.$watchTargets ? o.concat(c.$watchTargets) : o, []);
  let s = () => !1;
  return t.length && (s = a ? Re(t) : qe(t)), {
    $async: a,
    $validator: s,
    $watchTargets: n
  };
}
function Fe() {
  return V({
    type: "and"
  }, b("The value does not match all of the provided validators", Ue(...arguments)));
}
function Ke(e) {
  return function(t, r) {
    if (!d(t))
      return !0;
    const a = h(e).call(this, t, r);
    return te(a) ? a.then((n) => !$(n)) : !$(a);
  };
}
function We(e) {
  return {
    $validator: Ke(e),
    $message: "The value does not match the provided validator",
    $params: {
      type: "not"
    }
  };
}
function Ge(e) {
  return (t) => !d(t) || (!/\s/.test(t) || t instanceof Date) && +t >= +l(e);
}
function Je(e) {
  return {
    $validator: Ge(e),
    $message: (t) => {
      let {
        $params: r
      } = t;
      return `The minimum value allowed is ${r.min}`;
    },
    $params: {
      min: e,
      type: "minValue"
    }
  };
}
function Ze(e) {
  return (t) => !d(t) || (!/\s/.test(t) || t instanceof Date) && +t <= +l(e);
}
var He = (e) => ({
  $validator: Ze(e),
  $message: (t) => {
    let {
      $params: r
    } = t;
    return `The maximum value allowed is ${r.max}`;
  },
  $params: {
    max: e,
    type: "maxValue"
  }
}), Qe = f(/(^[0-9]*$)|(^-[0-9]+$)/), Xe = {
  $validator: Qe,
  $message: "Value is not an integer",
  $params: {
    type: "integer"
  }
}, Ye = f(/^[-]?\d*(\.\d+)?$/), et = {
  $validator: Ye,
  $message: "Value must be decimal",
  $params: {
    type: "decimal"
  }
};
function tt(e) {
  let {
    t,
    messagePath: r = (n) => {
      let {
        $validator: s
      } = n;
      return `validations.${s}`;
    },
    messageParams: a = (n) => n
  } = e;
  return function(n) {
    let {
      withArguments: s = !1,
      messagePath: o = r,
      messageParams: c = a
    } = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
    function i(u) {
      return t(o(u), c(v({
        model: u.$model,
        property: u.$property,
        pending: u.$pending,
        invalid: u.$invalid,
        response: u.$response,
        validator: u.$validator,
        propertyPath: u.$propertyPath
      }, u.$params)));
    }
    return s && typeof n == "function" ? function() {
      return b(i, n(...arguments));
    } : b(i, n);
  };
}
const ht = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  alpha: oe,
  alphaNum: ue,
  and: Fe,
  between: me,
  createI18nMessage: tt,
  decimal: et,
  email: fe,
  helpers: ne,
  integer: Xe,
  ipAddress: ve,
  macAddress: xe,
  maxLength: Te,
  maxValue: He,
  minLength: je,
  minValue: Je,
  not: We,
  numeric: le,
  or: Ne,
  required: De,
  requiredIf: Se,
  requiredUnless: Ee,
  sameAs: Ce,
  url: _e
}, Symbol.toStringTag, { value: "Module" }));
var rt = Object.defineProperty, at = (e, t, r) => t in e ? rt(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r, g = (e, t, r) => (at(e, typeof t != "symbol" ? t + "" : t, r), r);
const nt = (e, t) => t.some((r) => e instanceof r);
let K, W;
function st() {
  return K || (K = [
    IDBDatabase,
    IDBObjectStore,
    IDBIndex,
    IDBCursor,
    IDBTransaction
  ]);
}
function ot() {
  return W || (W = [
    IDBCursor.prototype.advance,
    IDBCursor.prototype.continue,
    IDBCursor.prototype.continuePrimaryKey
  ]);
}
const J = /* @__PURE__ */ new WeakMap(), B = /* @__PURE__ */ new WeakMap(), Z = /* @__PURE__ */ new WeakMap(), E = /* @__PURE__ */ new WeakMap(), M = /* @__PURE__ */ new WeakMap();
function it(e) {
  const t = new Promise((r, a) => {
    const n = () => {
      e.removeEventListener("success", s), e.removeEventListener("error", o);
    }, s = () => {
      r(p(e.result)), n();
    }, o = () => {
      a(e.error), n();
    };
    e.addEventListener("success", s), e.addEventListener("error", o);
  });
  return t.then((r) => {
    r instanceof IDBCursor && J.set(r, e);
  }).catch(() => {
  }), M.set(t, e), t;
}
function ut(e) {
  if (B.has(e))
    return;
  const t = new Promise((r, a) => {
    const n = () => {
      e.removeEventListener("complete", s), e.removeEventListener("error", o), e.removeEventListener("abort", o);
    }, s = () => {
      r(), n();
    }, o = () => {
      a(e.error || new DOMException("AbortError", "AbortError")), n();
    };
    e.addEventListener("complete", s), e.addEventListener("error", o), e.addEventListener("abort", o);
  });
  B.set(e, t);
}
let L = {
  get(e, t, r) {
    if (e instanceof IDBTransaction) {
      if (t === "done")
        return B.get(e);
      if (t === "objectStoreNames")
        return e.objectStoreNames || Z.get(e);
      if (t === "store")
        return r.objectStoreNames[1] ? void 0 : r.objectStore(r.objectStoreNames[0]);
    }
    return p(e[t]);
  },
  set(e, t, r) {
    return e[t] = r, !0;
  },
  has(e, t) {
    return e instanceof IDBTransaction && (t === "done" || t === "store") ? !0 : t in e;
  }
};
function ct(e) {
  L = e(L);
}
function lt(e) {
  return e === IDBDatabase.prototype.transaction && !("objectStoreNames" in IDBTransaction.prototype) ? function(t, ...r) {
    const a = e.call(P(this), t, ...r);
    return Z.set(a, t.sort ? t.sort() : [t]), p(a);
  } : ot().includes(e) ? function(...t) {
    return e.apply(P(this), t), p(J.get(this));
  } : function(...t) {
    return p(e.apply(P(this), t));
  };
}
function dt(e) {
  return typeof e == "function" ? lt(e) : (e instanceof IDBTransaction && ut(e), nt(e, st()) ? new Proxy(e, L) : e);
}
function p(e) {
  if (e instanceof IDBRequest)
    return it(e);
  if (E.has(e))
    return E.get(e);
  const t = dt(e);
  return t !== e && (E.set(e, t), M.set(t, e)), t;
}
const P = (e) => M.get(e);
function mt(e, t, { blocked: r, upgrade: a, blocking: n, terminated: s } = {}) {
  const o = indexedDB.open(e, t), c = p(o);
  return a && o.addEventListener("upgradeneeded", (i) => {
    a(p(o.result), i.oldVersion, i.newVersion, p(o.transaction), i);
  }), r && o.addEventListener("blocked", (i) => r(
    // Casting due to https://github.com/microsoft/TypeScript-DOM-lib-generator/pull/1405
    i.oldVersion,
    i.newVersion,
    i
  )), c.then((i) => {
    s && i.addEventListener("close", () => s()), n && i.addEventListener("versionchange", (u) => n(u.oldVersion, u.newVersion, u));
  }).catch(() => {
  }), c;
}
const pt = ["get", "getKey", "getAll", "getAllKeys", "count"], $t = ["put", "add", "delete", "clear"], C = /* @__PURE__ */ new Map();
function G(e, t) {
  if (!(e instanceof IDBDatabase && !(t in e) && typeof t == "string"))
    return;
  if (C.get(t))
    return C.get(t);
  const r = t.replace(/FromIndex$/, ""), a = t !== r, n = $t.includes(r);
  if (
    // Bail if the target doesn't exist on the target. Eg, getAll isn't in Edge.
    !(r in (a ? IDBIndex : IDBObjectStore).prototype) || !(n || pt.includes(r))
  )
    return;
  const s = async function(o, ...c) {
    const i = this.transaction(o, n ? "readwrite" : "readonly");
    let u = i.store;
    return a && (u = u.index(c.shift())), (await Promise.all([
      u[r](...c),
      n && i.done
    ]))[0];
  };
  return C.set(t, s), s;
}
ct((e) => ({
  ...e,
  get: (t, r, a) => G(t, r) || e.get(t, r, a),
  has: (t, r) => !!G(t, r) || e.has(t, r)
}));
class vt {
  constructor(t, r) {
    g(this, "hash"), g(this, "data"), this.hash = t, this.data = r;
  }
}
class H {
  constructor() {
    g(this, "DB_NAME", "cacheDB"), g(this, "db");
  }
  //   public static Instance = async () => {
  //     if (!CachingServiceClass._instance) {
  //       CachingServiceClass._instance = new CachingServiceClass()
  //       await CachingServiceClass._instance.createObjectStore()
  //     }
  //     return CachingServiceClass._instance
  //   }
  static get Instance() {
    return this._instance || (this._instance = new this(), this._instance.createObjectStore()), this._instance;
  }
  async createObjectStore() {
    this.db = await mt(this.DB_NAME, 1, {
      upgrade(t) {
        t.createObjectStore("cache");
      }
    });
  }
  async getCacheItem(t) {
    return await this.db.get("cache", t);
  }
  async insertCacheItem(t, r) {
    await this.db.add("cache", r, t);
  }
  async deleteCacheItem(t) {
    await this.db.delete("cache", t);
  }
  async clearCache() {
    await this.db.clear("cache");
  }
}
g(H, "_instance");
const yt = H.Instance, _ = class j {
  constructor() {
  }
  static get Instance() {
    return this._instance || (this._instance = new this());
  }
  setGlobalCookieOptions(t) {
    j._globalCookieOptions = t;
  }
  set(t, r, a) {
    if (t) {
      if (/^(?:expires|max-age|path|domain|secure|SameSite)$/i.test(t))
        throw new Error(`Cookie name illegality. Cannot be set to ["expires","max-age","path","domain","secure","SameSite"]	 current key name: ${t}`);
    } else
      throw new Error("Cookie name is not found in the first argument.");
    const n = r && r.constructor === Object ? JSON.stringify(r) : r;
    let s = "";
    if (a ?? (a = j._globalCookieOptions), a.expireTimes === void 0 && (a.expireTimes = ""), a.expireTimes && a.expireTimes != 0)
      switch (a.expireTimes.constructor) {
        case Number:
          a.expireTimes === 1 / 0 || a.expireTimes === -1 ? s = "; expires=Fri, 31 Dec 9999 23:59:59 GMT" : s = "; max-age=" + a.expireTimes;
          break;
        case String:
          if (/^(?:\d+(y|m|d|h|min|s))$/i.test(a.expireTimes)) {
            const i = a.expireTimes.replace(
              /^(\d+)(?:y|m|d|h|min|s)$/i,
              "$1"
            );
            switch (a.expireTimes.replace(/^(?:\d+)(y|m|d|h|min|s)$/i, "$1").toLowerCase()) {
              case "m":
                s = "; max-age=" + +i * 2592e3;
                break;
              case "d":
                s = "; max-age=" + +i * 86400;
                break;
              case "h":
                s = "; max-age=" + +i * 3600;
                break;
              case "min":
                s = "; max-age=" + +i * 60;
                break;
              case "s":
                s = "; max-age=" + i;
                break;
              case "y":
                s = "; max-age=" + +i * 31104e3;
                break;
            }
          } else
            s = "; expires=" + a.expireTimes;
          break;
        case Date:
          s = "; expires=" + a.expireTimes.toUTCString();
          break;
      }
    a.domain ?? (a.domain = ""), a.path ?? (a.path = "/"), a.sameSite ?? (a.sameSite = "");
    const o = `domain=${a.domain}; path=${a.path}; Secure=${a.secure}; SameSite=${a.sameSite}${s}`, c = `${encodeURIComponent(t)}=${encodeURIComponent(n)}; ${o}`;
    document.cookie = c;
  }
  get(t) {
    let r = decodeURIComponent(document.cookie.replace(new RegExp("(?:(?:^|.*;)\\s*" + encodeURIComponent(t).replace(/[\-\.\+\*]/g, "\\$&") + "\\s*\\=\\s*([^;]*).*$)|^.*$"), "$1")) || null;
    if (r && r.substring(0, 1) === "{" && r.substring(r.length - 1, r.length) === "}")
      try {
        return JSON.parse(r);
      } catch {
        return r;
      }
    return r;
  }
  isKey(t) {
    return new RegExp("(?:^|;\\s*)" + encodeURIComponent(t).replace(/[\-\.\+\*]/g, "\\$&") + "\\s*\\=").test(document.cookie);
  }
  remove(t, r) {
    if (!t || !this.isKey(t))
      return !1;
    r ?? (r = j._globalCookieOptions), r.domain ?? (r.domain = ""), r.path ?? (r.path = "/");
    const a = `domain=${r.domain}; path=${r.path};`;
    return document.cookie = `${encodeURIComponent(t)}=; expires=Thu, 01 Jan 1970 00:00:00 GMT; ${a}`, !0;
  }
};
g(_, "_instance"), g(_, "_globalCookieOptions");
let ft = _;
const bt = () => ft.Instance;
export {
  oe as B,
  Je as E,
  ne as F,
  ue as H,
  et as I,
  bt as K,
  Xe as L,
  He as N,
  le as Q,
  vt as W,
  me as X,
  ht as a,
  yt as b,
  je as c,
  De as f,
  Ee as g,
  Ce as h,
  fe as k,
  Se as m,
  xe as s,
  ve as t,
  Te as u,
  _e as v
};
