import { ApiEndpoint } from './api-service';
export declare class ApiServiceEndpoints {
    static readonly AUTH: {
        readonly Register: ApiEndpoint;
        readonly Login: ApiEndpoint;
    };
    static readonly INVENTORY: {
        readonly Get: ApiEndpoint;
        readonly GetItemModels: ApiEndpoint;
        readonly PostItemModel: ApiEndpoint;
        readonly PatchItemModel: ApiEndpoint;
        readonly DeleteItemModel: ApiEndpoint;
        readonly GetDiskTypes: ApiEndpoint;
        readonly PostDiskType: ApiEndpoint;
        readonly PatchDiskType: ApiEndpoint;
        readonly DeleteDiskType: ApiEndpoint;
        readonly GetItemTypes: ApiEndpoint;
        readonly PostItemType: ApiEndpoint;
        readonly PatchItemType: ApiEndpoint;
        readonly DeleteItemType: ApiEndpoint;
        readonly GetModelMappings: ApiEndpoint;
        readonly PostModelMappings: ApiEndpoint;
        readonly PatchModelMappings: ApiEndpoint;
        readonly DeleteModelMappings: ApiEndpoint;
        readonly GetClientDiscounts: ApiEndpoint;
        readonly PostClientDiscount: ApiEndpoint;
        readonly PatchClientDiscount: ApiEndpoint;
        readonly DeleteClientDiscount: ApiEndpoint;
    };
    static readonly OFFERS: {
        readonly Get: ApiEndpoint;
        readonly Post: ApiEndpoint;
        readonly Patch: ApiEndpoint;
        readonly Delete: ApiEndpoint;
        readonly GetTags: ApiEndpoint;
        readonly PostTags: ApiEndpoint;
        readonly DeleteTags: ApiEndpoint;
    };
    static readonly ORDERS: {
        readonly Get: ApiEndpoint;
        readonly GetStatuses: ApiEndpoint;
        readonly Create: ApiEndpoint;
        readonly Update: ApiEndpoint;
        readonly Delete: ApiEndpoint;
        readonly DeleteOrderItem: ApiEndpoint;
        readonly UpdateOrderItem: ApiEndpoint;
        readonly CreateOrderEntry: ApiEndpoint;
    };
    static readonly CLIENT_PRODUCTS: {
        readonly Get: ApiEndpoint;
        readonly Post: ApiEndpoint;
        readonly Patch: ApiEndpoint;
    };
    static readonly CLUSTER: {
        readonly GetVMs: ApiEndpoint;
        readonly GetIps: ApiEndpoint;
        readonly PostIp: ApiEndpoint;
        readonly PatchIp: ApiEndpoint;
        readonly DeleteIp: ApiEndpoint;
        readonly GetIpsets: ApiEndpoint;
        readonly PostIpset: ApiEndpoint;
        readonly PatchIpset: ApiEndpoint;
        readonly DeleteIpset: ApiEndpoint;
        readonly GetIpsetsIps: ApiEndpoint;
        readonly PostIpsetsIp: ApiEndpoint;
        readonly PatchIpsetsIp: ApiEndpoint;
        readonly DeleteIpsetsIp: ApiEndpoint;
        readonly GetIpsetsVms: ApiEndpoint;
        readonly PostIpsetsVm: ApiEndpoint;
        readonly PatchIpsetsVm: ApiEndpoint;
        readonly DeleteIpsetsVm: ApiEndpoint;
        readonly PostToggleLockVM: ApiEndpoint;
        readonly AddIPArrayToIPSet: ApiEndpoint;
    };
}
