import "vue";
import "./services-b1c6f11d.js";
const co = {
  CSV: "text/csv",
  JSON: "application/json"
}, ho = {
  Exact: "exact",
  Planned: "planned"
}, fo = {
  Presentation: "presentation",
  Representation: "representation"
};
var pe = /* @__PURE__ */ ((t) => (t.SUCCESS = "success", t.INFO = "info", t.WARN = "warn", t.ERROR = "error", t))(pe || {});
//! moment.js
//! version : 2.29.4
//! authors : Tim Wood, Iskren Chernev, Moment.js contributors
//! license : MIT
//! momentjs.com
var Ke;
function l() {
  return Ke.apply(null, arguments);
}
function rr(t) {
  Ke = t;
}
function J(t) {
  return t instanceof Array || Object.prototype.toString.call(t) === "[object Array]";
}
function gt(t) {
  return t != null && Object.prototype.toString.call(t) === "[object Object]";
}
function M(t, e) {
  return Object.prototype.hasOwnProperty.call(t, e);
}
function Ye(t) {
  if (Object.getOwnPropertyNames)
    return Object.getOwnPropertyNames(t).length === 0;
  var e;
  for (e in t)
    if (M(t, e))
      return !1;
  return !0;
}
function H(t) {
  return t === void 0;
}
function lt(t) {
  return typeof t == "number" || Object.prototype.toString.call(t) === "[object Number]";
}
function Wt(t) {
  return t instanceof Date || Object.prototype.toString.call(t) === "[object Date]";
}
function tn(t, e) {
  var n = [], r, i = t.length;
  for (r = 0; r < i; ++r)
    n.push(e(t[r], r));
  return n;
}
function ht(t, e) {
  for (var n in e)
    M(e, n) && (t[n] = e[n]);
  return M(e, "toString") && (t.toString = e.toString), M(e, "valueOf") && (t.valueOf = e.valueOf), t;
}
function nt(t, e, n, r) {
  return bn(t, e, n, r, !0).utc();
}
function ir() {
  return {
    empty: !1,
    unusedTokens: [],
    unusedInput: [],
    overflow: -2,
    charsLeftOver: 0,
    nullInput: !1,
    invalidEra: null,
    invalidMonth: null,
    invalidFormat: !1,
    userInvalidated: !1,
    iso: !1,
    parsedDateParts: [],
    era: null,
    meridiem: null,
    rfc2822: !1,
    weekdayMismatch: !1
  };
}
function v(t) {
  return t._pf == null && (t._pf = ir()), t._pf;
}
var ve;
Array.prototype.some ? ve = Array.prototype.some : ve = function(t) {
  var e = Object(this), n = e.length >>> 0, r;
  for (r = 0; r < n; r++)
    if (r in e && t.call(this, e[r], r, e))
      return !0;
  return !1;
};
function Oe(t) {
  if (t._isValid == null) {
    var e = v(t), n = ve.call(e.parsedDateParts, function(i) {
      return i != null;
    }), r = !isNaN(t._d.getTime()) && e.overflow < 0 && !e.empty && !e.invalidEra && !e.invalidMonth && !e.invalidWeekday && !e.weekdayMismatch && !e.nullInput && !e.invalidFormat && !e.userInvalidated && (!e.meridiem || e.meridiem && n);
    if (t._strict && (r = r && e.charsLeftOver === 0 && e.unusedTokens.length === 0 && e.bigHour === void 0), Object.isFrozen == null || !Object.isFrozen(t))
      t._isValid = r;
    else
      return r;
  }
  return t._isValid;
}
function Kt(t) {
  var e = nt(NaN);
  return t != null ? ht(v(e), t) : v(e).userInvalidated = !0, e;
}
var qe = l.momentProperties = [], me = !1;
function Te(t, e) {
  var n, r, i, s = qe.length;
  if (H(e._isAMomentObject) || (t._isAMomentObject = e._isAMomentObject), H(e._i) || (t._i = e._i), H(e._f) || (t._f = e._f), H(e._l) || (t._l = e._l), H(e._strict) || (t._strict = e._strict), H(e._tzm) || (t._tzm = e._tzm), H(e._isUTC) || (t._isUTC = e._isUTC), H(e._offset) || (t._offset = e._offset), H(e._pf) || (t._pf = v(e)), H(e._locale) || (t._locale = e._locale), s > 0)
    for (n = 0; n < s; n++)
      r = qe[n], i = e[r], H(i) || (t[r] = i);
  return t;
}
function At(t) {
  Te(this, t), this._d = new Date(t._d != null ? t._d.getTime() : NaN), this.isValid() || (this._d = /* @__PURE__ */ new Date(NaN)), me === !1 && (me = !0, l.updateOffset(this), me = !1);
}
function Q(t) {
  return t instanceof At || t != null && t._isAMomentObject != null;
}
function en(t) {
  l.suppressDeprecationWarnings === !1 && typeof console < "u" && console.warn && console.warn("Deprecation warning: " + t);
}
function z(t, e) {
  var n = !0;
  return ht(function() {
    if (l.deprecationHandler != null && l.deprecationHandler(null, t), n) {
      var r = [], i, s, a, o = arguments.length;
      for (s = 0; s < o; s++) {
        if (i = "", typeof arguments[s] == "object") {
          i += `
[` + s + "] ";
          for (a in arguments[0])
            M(arguments[0], a) && (i += a + ": " + arguments[0][a] + ", ");
          i = i.slice(0, -2);
        } else
          i = arguments[s];
        r.push(i);
      }
      en(
        t + `
Arguments: ` + Array.prototype.slice.call(r).join("") + `
` + new Error().stack
      ), n = !1;
    }
    return e.apply(this, arguments);
  }, e);
}
var Be = {};
function nn(t, e) {
  l.deprecationHandler != null && l.deprecationHandler(t, e), Be[t] || (en(e), Be[t] = !0);
}
l.suppressDeprecationWarnings = !1;
l.deprecationHandler = null;
function rt(t) {
  return typeof Function < "u" && t instanceof Function || Object.prototype.toString.call(t) === "[object Function]";
}
function sr(t) {
  var e, n;
  for (n in t)
    M(t, n) && (e = t[n], rt(e) ? this[n] = e : this["_" + n] = e);
  this._config = t, this._dayOfMonthOrdinalParseLenient = new RegExp(
    (this._dayOfMonthOrdinalParse.source || this._ordinalParse.source) + "|" + /\d{1,2}/.source
  );
}
function we(t, e) {
  var n = ht({}, t), r;
  for (r in e)
    M(e, r) && (gt(t[r]) && gt(e[r]) ? (n[r] = {}, ht(n[r], t[r]), ht(n[r], e[r])) : e[r] != null ? n[r] = e[r] : delete n[r]);
  for (r in t)
    M(t, r) && !M(e, r) && gt(t[r]) && (n[r] = ht({}, n[r]));
  return n;
}
function xe(t) {
  t != null && this.set(t);
}
var Se;
Object.keys ? Se = Object.keys : Se = function(t) {
  var e, n = [];
  for (e in t)
    M(t, e) && n.push(e);
  return n;
};
var ar = {
  sameDay: "[Today at] LT",
  nextDay: "[Tomorrow at] LT",
  nextWeek: "dddd [at] LT",
  lastDay: "[Yesterday at] LT",
  lastWeek: "[Last] dddd [at] LT",
  sameElse: "L"
};
function or(t, e, n) {
  var r = this._calendar[t] || this._calendar.sameElse;
  return rt(r) ? r.call(e, n) : r;
}
function et(t, e, n) {
  var r = "" + Math.abs(t), i = e - r.length, s = t >= 0;
  return (s ? n ? "+" : "" : "-") + Math.pow(10, Math.max(0, i)).toString().substr(1) + r;
}
var Ne = /(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g, Gt = /(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g, _e = {}, Mt = {};
function m(t, e, n, r) {
  var i = r;
  typeof r == "string" && (i = function() {
    return this[r]();
  }), t && (Mt[t] = i), e && (Mt[e[0]] = function() {
    return et(i.apply(this, arguments), e[1], e[2]);
  }), n && (Mt[n] = function() {
    return this.localeData().ordinal(
      i.apply(this, arguments),
      t
    );
  });
}
function ur(t) {
  return t.match(/\[[\s\S]/) ? t.replace(/^\[|\]$/g, "") : t.replace(/\\/g, "");
}
function lr(t) {
  var e = t.match(Ne), n, r;
  for (n = 0, r = e.length; n < r; n++)
    Mt[e[n]] ? e[n] = Mt[e[n]] : e[n] = ur(e[n]);
  return function(i) {
    var s = "", a;
    for (a = 0; a < r; a++)
      s += rt(e[a]) ? e[a].call(i, t) : e[a];
    return s;
  };
}
function jt(t, e) {
  return t.isValid() ? (e = rn(e, t.localeData()), _e[e] = _e[e] || lr(e), _e[e](t)) : t.localeData().invalidDate();
}
function rn(t, e) {
  var n = 5;
  function r(i) {
    return e.longDateFormat(i) || i;
  }
  for (Gt.lastIndex = 0; n >= 0 && Gt.test(t); )
    t = t.replace(
      Gt,
      r
    ), Gt.lastIndex = 0, n -= 1;
  return t;
}
var cr = {
  LTS: "h:mm:ss A",
  LT: "h:mm A",
  L: "MM/DD/YYYY",
  LL: "MMMM D, YYYY",
  LLL: "MMMM D, YYYY h:mm A",
  LLLL: "dddd, MMMM D, YYYY h:mm A"
};
function dr(t) {
  var e = this._longDateFormat[t], n = this._longDateFormat[t.toUpperCase()];
  return e || !n ? e : (this._longDateFormat[t] = n.match(Ne).map(function(r) {
    return r === "MMMM" || r === "MM" || r === "DD" || r === "dddd" ? r.slice(1) : r;
  }).join(""), this._longDateFormat[t]);
}
var hr = "Invalid date";
function fr() {
  return this._invalidDate;
}
var mr = "%d", _r = /\d{1,2}/;
function yr(t) {
  return this._ordinal.replace("%d", t);
}
var gr = {
  future: "in %s",
  past: "%s ago",
  s: "a few seconds",
  ss: "%d seconds",
  m: "a minute",
  mm: "%d minutes",
  h: "an hour",
  hh: "%d hours",
  d: "a day",
  dd: "%d days",
  w: "a week",
  ww: "%d weeks",
  M: "a month",
  MM: "%d months",
  y: "a year",
  yy: "%d years"
};
function pr(t, e, n, r) {
  var i = this._relativeTime[n];
  return rt(i) ? i(t, e, n, r) : i.replace(/%d/i, t);
}
function vr(t, e) {
  var n = this._relativeTime[t > 0 ? "future" : "past"];
  return rt(n) ? n(e) : n.replace(/%s/i, e);
}
var Nt = {};
function F(t, e) {
  var n = t.toLowerCase();
  Nt[n] = Nt[n + "s"] = Nt[e] = t;
}
function Z(t) {
  return typeof t == "string" ? Nt[t] || Nt[t.toLowerCase()] : void 0;
}
function Re(t) {
  var e = {}, n, r;
  for (r in t)
    M(t, r) && (n = Z(r), n && (e[n] = t[r]));
  return e;
}
var sn = {};
function U(t, e) {
  sn[t] = e;
}
function wr(t) {
  var e = [], n;
  for (n in t)
    M(t, n) && e.push({ unit: n, priority: sn[n] });
  return e.sort(function(r, i) {
    return r.priority - i.priority;
  }), e;
}
function te(t) {
  return t % 4 === 0 && t % 100 !== 0 || t % 400 === 0;
}
function $(t) {
  return t < 0 ? Math.ceil(t) || 0 : Math.floor(t);
}
function w(t) {
  var e = +t, n = 0;
  return e !== 0 && isFinite(e) && (n = $(e)), n;
}
function bt(t, e) {
  return function(n) {
    return n != null ? (an(this, t, n), l.updateOffset(this, e), this) : Zt(this, t);
  };
}
function Zt(t, e) {
  return t.isValid() ? t._d["get" + (t._isUTC ? "UTC" : "") + e]() : NaN;
}
function an(t, e, n) {
  t.isValid() && !isNaN(n) && (e === "FullYear" && te(t.year()) && t.month() === 1 && t.date() === 29 ? (n = w(n), t._d["set" + (t._isUTC ? "UTC" : "") + e](
    n,
    t.month(),
    ae(n, t.month())
  )) : t._d["set" + (t._isUTC ? "UTC" : "") + e](n));
}
function Sr(t) {
  return t = Z(t), rt(this[t]) ? this[t]() : this;
}
function Mr(t, e) {
  if (typeof t == "object") {
    t = Re(t);
    var n = wr(t), r, i = n.length;
    for (r = 0; r < i; r++)
      this[n[r].unit](t[n[r].unit]);
  } else if (t = Z(t), rt(this[t]))
    return this[t](e);
  return this;
}
var on = /\d/, V = /\d\d/, un = /\d{3}/, Pe = /\d{4}/, ee = /[+-]?\d{6}/, R = /\d\d?/, ln = /\d\d\d\d?/, cn = /\d\d\d\d\d\d?/, ne = /\d{1,3}/, Ee = /\d{1,4}/, re = /[+-]?\d{1,6}/, Yt = /\d+/, ie = /[+-]?\d+/, kr = /Z|[+-]\d\d:?\d\d/gi, se = /Z|[+-]\d\d(?::?\d\d)?/gi, Dr = /[+-]?\d+(\.\d{1,3})?/, Lt = /[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i, qt;
qt = {};
function d(t, e, n) {
  qt[t] = rt(e) ? e : function(r, i) {
    return r && n ? n : e;
  };
}
function br(t, e) {
  return M(qt, t) ? qt[t](e._strict, e._locale) : new RegExp(Yr(t));
}
function Yr(t) {
  return G(
    t.replace("\\", "").replace(
      /\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,
      function(e, n, r, i, s) {
        return n || r || i || s;
      }
    )
  );
}
function G(t) {
  return t.replace(/[-\/\\^$*+?.()|[\]{}]/g, "\\$&");
}
var Me = {};
function O(t, e) {
  var n, r = e, i;
  for (typeof t == "string" && (t = [t]), lt(e) && (r = function(s, a) {
    a[e] = w(s);
  }), i = t.length, n = 0; n < i; n++)
    Me[t[n]] = r;
}
function Ft(t, e) {
  O(t, function(n, r, i, s) {
    i._w = i._w || {}, e(n, i._w, i, s);
  });
}
function Or(t, e, n) {
  e != null && M(Me, t) && Me[t](e, n._a, n, t);
}
var L = 0, at = 1, tt = 2, W = 3, B = 4, ot = 5, yt = 6, Tr = 7, xr = 8;
function Nr(t, e) {
  return (t % e + e) % e;
}
var E;
Array.prototype.indexOf ? E = Array.prototype.indexOf : E = function(t) {
  var e;
  for (e = 0; e < this.length; ++e)
    if (this[e] === t)
      return e;
  return -1;
};
function ae(t, e) {
  if (isNaN(t) || isNaN(e))
    return NaN;
  var n = Nr(e, 12);
  return t += (e - n) / 12, n === 1 ? te(t) ? 29 : 28 : 31 - n % 7 % 2;
}
m("M", ["MM", 2], "Mo", function() {
  return this.month() + 1;
});
m("MMM", 0, 0, function(t) {
  return this.localeData().monthsShort(this, t);
});
m("MMMM", 0, 0, function(t) {
  return this.localeData().months(this, t);
});
F("month", "M");
U("month", 8);
d("M", R);
d("MM", R, V);
d("MMM", function(t, e) {
  return e.monthsShortRegex(t);
});
d("MMMM", function(t, e) {
  return e.monthsRegex(t);
});
O(["M", "MM"], function(t, e) {
  e[at] = w(t) - 1;
});
O(["MMM", "MMMM"], function(t, e, n, r) {
  var i = n._locale.monthsParse(t, r, n._strict);
  i != null ? e[at] = i : v(n).invalidMonth = t;
});
var Rr = "January_February_March_April_May_June_July_August_September_October_November_December".split(
  "_"
), dn = "Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"), hn = /D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/, Pr = Lt, Er = Lt;
function Cr(t, e) {
  return t ? J(this._months) ? this._months[t.month()] : this._months[(this._months.isFormat || hn).test(e) ? "format" : "standalone"][t.month()] : J(this._months) ? this._months : this._months.standalone;
}
function Wr(t, e) {
  return t ? J(this._monthsShort) ? this._monthsShort[t.month()] : this._monthsShort[hn.test(e) ? "format" : "standalone"][t.month()] : J(this._monthsShort) ? this._monthsShort : this._monthsShort.standalone;
}
function Ar(t, e, n) {
  var r, i, s, a = t.toLocaleLowerCase();
  if (!this._monthsParse)
    for (this._monthsParse = [], this._longMonthsParse = [], this._shortMonthsParse = [], r = 0; r < 12; ++r)
      s = nt([2e3, r]), this._shortMonthsParse[r] = this.monthsShort(
        s,
        ""
      ).toLocaleLowerCase(), this._longMonthsParse[r] = this.months(s, "").toLocaleLowerCase();
  return n ? e === "MMM" ? (i = E.call(this._shortMonthsParse, a), i !== -1 ? i : null) : (i = E.call(this._longMonthsParse, a), i !== -1 ? i : null) : e === "MMM" ? (i = E.call(this._shortMonthsParse, a), i !== -1 ? i : (i = E.call(this._longMonthsParse, a), i !== -1 ? i : null)) : (i = E.call(this._longMonthsParse, a), i !== -1 ? i : (i = E.call(this._shortMonthsParse, a), i !== -1 ? i : null));
}
function Lr(t, e, n) {
  var r, i, s;
  if (this._monthsParseExact)
    return Ar.call(this, t, e, n);
  for (this._monthsParse || (this._monthsParse = [], this._longMonthsParse = [], this._shortMonthsParse = []), r = 0; r < 12; r++)
    if (i = nt([2e3, r]), n && !this._longMonthsParse[r] && (this._longMonthsParse[r] = new RegExp(
      "^" + this.months(i, "").replace(".", "") + "$",
      "i"
    ), this._shortMonthsParse[r] = new RegExp(
      "^" + this.monthsShort(i, "").replace(".", "") + "$",
      "i"
    )), !n && !this._monthsParse[r] && (s = "^" + this.months(i, "") + "|^" + this.monthsShort(i, ""), this._monthsParse[r] = new RegExp(s.replace(".", ""), "i")), n && e === "MMMM" && this._longMonthsParse[r].test(t) || n && e === "MMM" && this._shortMonthsParse[r].test(t) || !n && this._monthsParse[r].test(t))
      return r;
}
function fn(t, e) {
  var n;
  if (!t.isValid())
    return t;
  if (typeof e == "string") {
    if (/^\d+$/.test(e))
      e = w(e);
    else if (e = t.localeData().monthsParse(e), !lt(e))
      return t;
  }
  return n = Math.min(t.date(), ae(t.year(), e)), t._d["set" + (t._isUTC ? "UTC" : "") + "Month"](e, n), t;
}
function mn(t) {
  return t != null ? (fn(this, t), l.updateOffset(this, !0), this) : Zt(this, "Month");
}
function Fr() {
  return ae(this.year(), this.month());
}
function Ur(t) {
  return this._monthsParseExact ? (M(this, "_monthsRegex") || _n.call(this), t ? this._monthsShortStrictRegex : this._monthsShortRegex) : (M(this, "_monthsShortRegex") || (this._monthsShortRegex = Pr), this._monthsShortStrictRegex && t ? this._monthsShortStrictRegex : this._monthsShortRegex);
}
function Hr(t) {
  return this._monthsParseExact ? (M(this, "_monthsRegex") || _n.call(this), t ? this._monthsStrictRegex : this._monthsRegex) : (M(this, "_monthsRegex") || (this._monthsRegex = Er), this._monthsStrictRegex && t ? this._monthsStrictRegex : this._monthsRegex);
}
function _n() {
  function t(a, o) {
    return o.length - a.length;
  }
  var e = [], n = [], r = [], i, s;
  for (i = 0; i < 12; i++)
    s = nt([2e3, i]), e.push(this.monthsShort(s, "")), n.push(this.months(s, "")), r.push(this.months(s, "")), r.push(this.monthsShort(s, ""));
  for (e.sort(t), n.sort(t), r.sort(t), i = 0; i < 12; i++)
    e[i] = G(e[i]), n[i] = G(n[i]);
  for (i = 0; i < 24; i++)
    r[i] = G(r[i]);
  this._monthsRegex = new RegExp("^(" + r.join("|") + ")", "i"), this._monthsShortRegex = this._monthsRegex, this._monthsStrictRegex = new RegExp(
    "^(" + n.join("|") + ")",
    "i"
  ), this._monthsShortStrictRegex = new RegExp(
    "^(" + e.join("|") + ")",
    "i"
  );
}
m("Y", 0, 0, function() {
  var t = this.year();
  return t <= 9999 ? et(t, 4) : "+" + t;
});
m(0, ["YY", 2], 0, function() {
  return this.year() % 100;
});
m(0, ["YYYY", 4], 0, "year");
m(0, ["YYYYY", 5], 0, "year");
m(0, ["YYYYYY", 6, !0], 0, "year");
F("year", "y");
U("year", 1);
d("Y", ie);
d("YY", R, V);
d("YYYY", Ee, Pe);
d("YYYYY", re, ee);
d("YYYYYY", re, ee);
O(["YYYYY", "YYYYYY"], L);
O("YYYY", function(t, e) {
  e[L] = t.length === 2 ? l.parseTwoDigitYear(t) : w(t);
});
O("YY", function(t, e) {
  e[L] = l.parseTwoDigitYear(t);
});
O("Y", function(t, e) {
  e[L] = parseInt(t, 10);
});
function Rt(t) {
  return te(t) ? 366 : 365;
}
l.parseTwoDigitYear = function(t) {
  return w(t) + (w(t) > 68 ? 1900 : 2e3);
};
var yn = bt("FullYear", !0);
function Ir() {
  return te(this.year());
}
function Gr(t, e, n, r, i, s, a) {
  var o;
  return t < 100 && t >= 0 ? (o = new Date(t + 400, e, n, r, i, s, a), isFinite(o.getFullYear()) && o.setFullYear(t)) : o = new Date(t, e, n, r, i, s, a), o;
}
function Pt(t) {
  var e, n;
  return t < 100 && t >= 0 ? (n = Array.prototype.slice.call(arguments), n[0] = t + 400, e = new Date(Date.UTC.apply(null, n)), isFinite(e.getUTCFullYear()) && e.setUTCFullYear(t)) : e = new Date(Date.UTC.apply(null, arguments)), e;
}
function Bt(t, e, n) {
  var r = 7 + e - n, i = (7 + Pt(t, 0, r).getUTCDay() - e) % 7;
  return -i + r - 1;
}
function gn(t, e, n, r, i) {
  var s = (7 + n - r) % 7, a = Bt(t, r, i), o = 1 + 7 * (e - 1) + s + a, c, h;
  return o <= 0 ? (c = t - 1, h = Rt(c) + o) : o > Rt(t) ? (c = t + 1, h = o - Rt(t)) : (c = t, h = o), {
    year: c,
    dayOfYear: h
  };
}
function Et(t, e, n) {
  var r = Bt(t.year(), e, n), i = Math.floor((t.dayOfYear() - r - 1) / 7) + 1, s, a;
  return i < 1 ? (a = t.year() - 1, s = i + ut(a, e, n)) : i > ut(t.year(), e, n) ? (s = i - ut(t.year(), e, n), a = t.year() + 1) : (a = t.year(), s = i), {
    week: s,
    year: a
  };
}
function ut(t, e, n) {
  var r = Bt(t, e, n), i = Bt(t + 1, e, n);
  return (Rt(t) - r + i) / 7;
}
m("w", ["ww", 2], "wo", "week");
m("W", ["WW", 2], "Wo", "isoWeek");
F("week", "w");
F("isoWeek", "W");
U("week", 5);
U("isoWeek", 5);
d("w", R);
d("ww", R, V);
d("W", R);
d("WW", R, V);
Ft(
  ["w", "ww", "W", "WW"],
  function(t, e, n, r) {
    e[r.substr(0, 1)] = w(t);
  }
);
function Vr(t) {
  return Et(t, this._week.dow, this._week.doy).week;
}
var jr = {
  dow: 0,
  // Sunday is the first day of the week.
  doy: 6
  // The week that contains Jan 6th is the first week of the year.
};
function $r() {
  return this._week.dow;
}
function zr() {
  return this._week.doy;
}
function Zr(t) {
  var e = this.localeData().week(this);
  return t == null ? e : this.add((t - e) * 7, "d");
}
function qr(t) {
  var e = Et(this, 1, 4).week;
  return t == null ? e : this.add((t - e) * 7, "d");
}
m("d", 0, "do", "day");
m("dd", 0, 0, function(t) {
  return this.localeData().weekdaysMin(this, t);
});
m("ddd", 0, 0, function(t) {
  return this.localeData().weekdaysShort(this, t);
});
m("dddd", 0, 0, function(t) {
  return this.localeData().weekdays(this, t);
});
m("e", 0, 0, "weekday");
m("E", 0, 0, "isoWeekday");
F("day", "d");
F("weekday", "e");
F("isoWeekday", "E");
U("day", 11);
U("weekday", 11);
U("isoWeekday", 11);
d("d", R);
d("e", R);
d("E", R);
d("dd", function(t, e) {
  return e.weekdaysMinRegex(t);
});
d("ddd", function(t, e) {
  return e.weekdaysShortRegex(t);
});
d("dddd", function(t, e) {
  return e.weekdaysRegex(t);
});
Ft(["dd", "ddd", "dddd"], function(t, e, n, r) {
  var i = n._locale.weekdaysParse(t, r, n._strict);
  i != null ? e.d = i : v(n).invalidWeekday = t;
});
Ft(["d", "e", "E"], function(t, e, n, r) {
  e[r] = w(t);
});
function Br(t, e) {
  return typeof t != "string" ? t : isNaN(t) ? (t = e.weekdaysParse(t), typeof t == "number" ? t : null) : parseInt(t, 10);
}
function Jr(t, e) {
  return typeof t == "string" ? e.weekdaysParse(t) % 7 || 7 : isNaN(t) ? null : t;
}
function Ce(t, e) {
  return t.slice(e, 7).concat(t.slice(0, e));
}
var Qr = "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), pn = "Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"), Xr = "Su_Mo_Tu_We_Th_Fr_Sa".split("_"), Kr = Lt, ti = Lt, ei = Lt;
function ni(t, e) {
  var n = J(this._weekdays) ? this._weekdays : this._weekdays[t && t !== !0 && this._weekdays.isFormat.test(e) ? "format" : "standalone"];
  return t === !0 ? Ce(n, this._week.dow) : t ? n[t.day()] : n;
}
function ri(t) {
  return t === !0 ? Ce(this._weekdaysShort, this._week.dow) : t ? this._weekdaysShort[t.day()] : this._weekdaysShort;
}
function ii(t) {
  return t === !0 ? Ce(this._weekdaysMin, this._week.dow) : t ? this._weekdaysMin[t.day()] : this._weekdaysMin;
}
function si(t, e, n) {
  var r, i, s, a = t.toLocaleLowerCase();
  if (!this._weekdaysParse)
    for (this._weekdaysParse = [], this._shortWeekdaysParse = [], this._minWeekdaysParse = [], r = 0; r < 7; ++r)
      s = nt([2e3, 1]).day(r), this._minWeekdaysParse[r] = this.weekdaysMin(
        s,
        ""
      ).toLocaleLowerCase(), this._shortWeekdaysParse[r] = this.weekdaysShort(
        s,
        ""
      ).toLocaleLowerCase(), this._weekdaysParse[r] = this.weekdays(s, "").toLocaleLowerCase();
  return n ? e === "dddd" ? (i = E.call(this._weekdaysParse, a), i !== -1 ? i : null) : e === "ddd" ? (i = E.call(this._shortWeekdaysParse, a), i !== -1 ? i : null) : (i = E.call(this._minWeekdaysParse, a), i !== -1 ? i : null) : e === "dddd" ? (i = E.call(this._weekdaysParse, a), i !== -1 || (i = E.call(this._shortWeekdaysParse, a), i !== -1) ? i : (i = E.call(this._minWeekdaysParse, a), i !== -1 ? i : null)) : e === "ddd" ? (i = E.call(this._shortWeekdaysParse, a), i !== -1 || (i = E.call(this._weekdaysParse, a), i !== -1) ? i : (i = E.call(this._minWeekdaysParse, a), i !== -1 ? i : null)) : (i = E.call(this._minWeekdaysParse, a), i !== -1 || (i = E.call(this._weekdaysParse, a), i !== -1) ? i : (i = E.call(this._shortWeekdaysParse, a), i !== -1 ? i : null));
}
function ai(t, e, n) {
  var r, i, s;
  if (this._weekdaysParseExact)
    return si.call(this, t, e, n);
  for (this._weekdaysParse || (this._weekdaysParse = [], this._minWeekdaysParse = [], this._shortWeekdaysParse = [], this._fullWeekdaysParse = []), r = 0; r < 7; r++)
    if (i = nt([2e3, 1]).day(r), n && !this._fullWeekdaysParse[r] && (this._fullWeekdaysParse[r] = new RegExp(
      "^" + this.weekdays(i, "").replace(".", "\\.?") + "$",
      "i"
    ), this._shortWeekdaysParse[r] = new RegExp(
      "^" + this.weekdaysShort(i, "").replace(".", "\\.?") + "$",
      "i"
    ), this._minWeekdaysParse[r] = new RegExp(
      "^" + this.weekdaysMin(i, "").replace(".", "\\.?") + "$",
      "i"
    )), this._weekdaysParse[r] || (s = "^" + this.weekdays(i, "") + "|^" + this.weekdaysShort(i, "") + "|^" + this.weekdaysMin(i, ""), this._weekdaysParse[r] = new RegExp(s.replace(".", ""), "i")), n && e === "dddd" && this._fullWeekdaysParse[r].test(t) || n && e === "ddd" && this._shortWeekdaysParse[r].test(t) || n && e === "dd" && this._minWeekdaysParse[r].test(t) || !n && this._weekdaysParse[r].test(t))
      return r;
}
function oi(t) {
  if (!this.isValid())
    return t != null ? this : NaN;
  var e = this._isUTC ? this._d.getUTCDay() : this._d.getDay();
  return t != null ? (t = Br(t, this.localeData()), this.add(t - e, "d")) : e;
}
function ui(t) {
  if (!this.isValid())
    return t != null ? this : NaN;
  var e = (this.day() + 7 - this.localeData()._week.dow) % 7;
  return t == null ? e : this.add(t - e, "d");
}
function li(t) {
  if (!this.isValid())
    return t != null ? this : NaN;
  if (t != null) {
    var e = Jr(t, this.localeData());
    return this.day(this.day() % 7 ? e : e - 7);
  } else
    return this.day() || 7;
}
function ci(t) {
  return this._weekdaysParseExact ? (M(this, "_weekdaysRegex") || We.call(this), t ? this._weekdaysStrictRegex : this._weekdaysRegex) : (M(this, "_weekdaysRegex") || (this._weekdaysRegex = Kr), this._weekdaysStrictRegex && t ? this._weekdaysStrictRegex : this._weekdaysRegex);
}
function di(t) {
  return this._weekdaysParseExact ? (M(this, "_weekdaysRegex") || We.call(this), t ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex) : (M(this, "_weekdaysShortRegex") || (this._weekdaysShortRegex = ti), this._weekdaysShortStrictRegex && t ? this._weekdaysShortStrictRegex : this._weekdaysShortRegex);
}
function hi(t) {
  return this._weekdaysParseExact ? (M(this, "_weekdaysRegex") || We.call(this), t ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex) : (M(this, "_weekdaysMinRegex") || (this._weekdaysMinRegex = ei), this._weekdaysMinStrictRegex && t ? this._weekdaysMinStrictRegex : this._weekdaysMinRegex);
}
function We() {
  function t(p, Y) {
    return Y.length - p.length;
  }
  var e = [], n = [], r = [], i = [], s, a, o, c, h;
  for (s = 0; s < 7; s++)
    a = nt([2e3, 1]).day(s), o = G(this.weekdaysMin(a, "")), c = G(this.weekdaysShort(a, "")), h = G(this.weekdays(a, "")), e.push(o), n.push(c), r.push(h), i.push(o), i.push(c), i.push(h);
  e.sort(t), n.sort(t), r.sort(t), i.sort(t), this._weekdaysRegex = new RegExp("^(" + i.join("|") + ")", "i"), this._weekdaysShortRegex = this._weekdaysRegex, this._weekdaysMinRegex = this._weekdaysRegex, this._weekdaysStrictRegex = new RegExp(
    "^(" + r.join("|") + ")",
    "i"
  ), this._weekdaysShortStrictRegex = new RegExp(
    "^(" + n.join("|") + ")",
    "i"
  ), this._weekdaysMinStrictRegex = new RegExp(
    "^(" + e.join("|") + ")",
    "i"
  );
}
function Ae() {
  return this.hours() % 12 || 12;
}
function fi() {
  return this.hours() || 24;
}
m("H", ["HH", 2], 0, "hour");
m("h", ["hh", 2], 0, Ae);
m("k", ["kk", 2], 0, fi);
m("hmm", 0, 0, function() {
  return "" + Ae.apply(this) + et(this.minutes(), 2);
});
m("hmmss", 0, 0, function() {
  return "" + Ae.apply(this) + et(this.minutes(), 2) + et(this.seconds(), 2);
});
m("Hmm", 0, 0, function() {
  return "" + this.hours() + et(this.minutes(), 2);
});
m("Hmmss", 0, 0, function() {
  return "" + this.hours() + et(this.minutes(), 2) + et(this.seconds(), 2);
});
function vn(t, e) {
  m(t, 0, 0, function() {
    return this.localeData().meridiem(
      this.hours(),
      this.minutes(),
      e
    );
  });
}
vn("a", !0);
vn("A", !1);
F("hour", "h");
U("hour", 13);
function wn(t, e) {
  return e._meridiemParse;
}
d("a", wn);
d("A", wn);
d("H", R);
d("h", R);
d("k", R);
d("HH", R, V);
d("hh", R, V);
d("kk", R, V);
d("hmm", ln);
d("hmmss", cn);
d("Hmm", ln);
d("Hmmss", cn);
O(["H", "HH"], W);
O(["k", "kk"], function(t, e, n) {
  var r = w(t);
  e[W] = r === 24 ? 0 : r;
});
O(["a", "A"], function(t, e, n) {
  n._isPm = n._locale.isPM(t), n._meridiem = t;
});
O(["h", "hh"], function(t, e, n) {
  e[W] = w(t), v(n).bigHour = !0;
});
O("hmm", function(t, e, n) {
  var r = t.length - 2;
  e[W] = w(t.substr(0, r)), e[B] = w(t.substr(r)), v(n).bigHour = !0;
});
O("hmmss", function(t, e, n) {
  var r = t.length - 4, i = t.length - 2;
  e[W] = w(t.substr(0, r)), e[B] = w(t.substr(r, 2)), e[ot] = w(t.substr(i)), v(n).bigHour = !0;
});
O("Hmm", function(t, e, n) {
  var r = t.length - 2;
  e[W] = w(t.substr(0, r)), e[B] = w(t.substr(r));
});
O("Hmmss", function(t, e, n) {
  var r = t.length - 4, i = t.length - 2;
  e[W] = w(t.substr(0, r)), e[B] = w(t.substr(r, 2)), e[ot] = w(t.substr(i));
});
function mi(t) {
  return (t + "").toLowerCase().charAt(0) === "p";
}
var _i = /[ap]\.?m?\.?/i, yi = bt("Hours", !0);
function gi(t, e, n) {
  return t > 11 ? n ? "pm" : "PM" : n ? "am" : "AM";
}
var Sn = {
  calendar: ar,
  longDateFormat: cr,
  invalidDate: hr,
  ordinal: mr,
  dayOfMonthOrdinalParse: _r,
  relativeTime: gr,
  months: Rr,
  monthsShort: dn,
  week: jr,
  weekdays: Qr,
  weekdaysMin: Xr,
  weekdaysShort: pn,
  meridiemParse: _i
}, P = {}, Tt = {}, Ct;
function pi(t, e) {
  var n, r = Math.min(t.length, e.length);
  for (n = 0; n < r; n += 1)
    if (t[n] !== e[n])
      return n;
  return r;
}
function Je(t) {
  return t && t.toLowerCase().replace("_", "-");
}
function vi(t) {
  for (var e = 0, n, r, i, s; e < t.length; ) {
    for (s = Je(t[e]).split("-"), n = s.length, r = Je(t[e + 1]), r = r ? r.split("-") : null; n > 0; ) {
      if (i = oe(s.slice(0, n).join("-")), i)
        return i;
      if (r && r.length >= n && pi(s, r) >= n - 1)
        break;
      n--;
    }
    e++;
  }
  return Ct;
}
function wi(t) {
  return t.match("^[^/\\\\]*$") != null;
}
function oe(t) {
  var e = null, n;
  if (P[t] === void 0 && typeof module < "u" && module && module.exports && wi(t))
    try {
      e = Ct._abbr, n = require, n("./locale/" + t), mt(e);
    } catch {
      P[t] = null;
    }
  return P[t];
}
function mt(t, e) {
  var n;
  return t && (H(e) ? n = ct(t) : n = Le(t, e), n ? Ct = n : typeof console < "u" && console.warn && console.warn(
    "Locale " + t + " not found. Did you forget to load it?"
  )), Ct._abbr;
}
function Le(t, e) {
  if (e !== null) {
    var n, r = Sn;
    if (e.abbr = t, P[t] != null)
      nn(
        "defineLocaleOverride",
        "use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."
      ), r = P[t]._config;
    else if (e.parentLocale != null)
      if (P[e.parentLocale] != null)
        r = P[e.parentLocale]._config;
      else if (n = oe(e.parentLocale), n != null)
        r = n._config;
      else
        return Tt[e.parentLocale] || (Tt[e.parentLocale] = []), Tt[e.parentLocale].push({
          name: t,
          config: e
        }), null;
    return P[t] = new xe(we(r, e)), Tt[t] && Tt[t].forEach(function(i) {
      Le(i.name, i.config);
    }), mt(t), P[t];
  } else
    return delete P[t], null;
}
function Si(t, e) {
  if (e != null) {
    var n, r, i = Sn;
    P[t] != null && P[t].parentLocale != null ? P[t].set(we(P[t]._config, e)) : (r = oe(t), r != null && (i = r._config), e = we(i, e), r == null && (e.abbr = t), n = new xe(e), n.parentLocale = P[t], P[t] = n), mt(t);
  } else
    P[t] != null && (P[t].parentLocale != null ? (P[t] = P[t].parentLocale, t === mt() && mt(t)) : P[t] != null && delete P[t]);
  return P[t];
}
function ct(t) {
  var e;
  if (t && t._locale && t._locale._abbr && (t = t._locale._abbr), !t)
    return Ct;
  if (!J(t)) {
    if (e = oe(t), e)
      return e;
    t = [t];
  }
  return vi(t);
}
function Mi() {
  return Se(P);
}
function Fe(t) {
  var e, n = t._a;
  return n && v(t).overflow === -2 && (e = n[at] < 0 || n[at] > 11 ? at : n[tt] < 1 || n[tt] > ae(n[L], n[at]) ? tt : n[W] < 0 || n[W] > 24 || n[W] === 24 && (n[B] !== 0 || n[ot] !== 0 || n[yt] !== 0) ? W : n[B] < 0 || n[B] > 59 ? B : n[ot] < 0 || n[ot] > 59 ? ot : n[yt] < 0 || n[yt] > 999 ? yt : -1, v(t)._overflowDayOfYear && (e < L || e > tt) && (e = tt), v(t)._overflowWeeks && e === -1 && (e = Tr), v(t)._overflowWeekday && e === -1 && (e = xr), v(t).overflow = e), t;
}
var ki = /^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/, Di = /^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/, bi = /Z|[+-]\d\d(?::?\d\d)?/, Vt = [
  ["YYYYYY-MM-DD", /[+-]\d{6}-\d\d-\d\d/],
  ["YYYY-MM-DD", /\d{4}-\d\d-\d\d/],
  ["GGGG-[W]WW-E", /\d{4}-W\d\d-\d/],
  ["GGGG-[W]WW", /\d{4}-W\d\d/, !1],
  ["YYYY-DDD", /\d{4}-\d{3}/],
  ["YYYY-MM", /\d{4}-\d\d/, !1],
  ["YYYYYYMMDD", /[+-]\d{10}/],
  ["YYYYMMDD", /\d{8}/],
  ["GGGG[W]WWE", /\d{4}W\d{3}/],
  ["GGGG[W]WW", /\d{4}W\d{2}/, !1],
  ["YYYYDDD", /\d{7}/],
  ["YYYYMM", /\d{6}/, !1],
  ["YYYY", /\d{4}/, !1]
], ye = [
  ["HH:mm:ss.SSSS", /\d\d:\d\d:\d\d\.\d+/],
  ["HH:mm:ss,SSSS", /\d\d:\d\d:\d\d,\d+/],
  ["HH:mm:ss", /\d\d:\d\d:\d\d/],
  ["HH:mm", /\d\d:\d\d/],
  ["HHmmss.SSSS", /\d\d\d\d\d\d\.\d+/],
  ["HHmmss,SSSS", /\d\d\d\d\d\d,\d+/],
  ["HHmmss", /\d\d\d\d\d\d/],
  ["HHmm", /\d\d\d\d/],
  ["HH", /\d\d/]
], Yi = /^\/?Date\((-?\d+)/i, Oi = /^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/, Ti = {
  UT: 0,
  GMT: 0,
  EDT: -4 * 60,
  EST: -5 * 60,
  CDT: -5 * 60,
  CST: -6 * 60,
  MDT: -6 * 60,
  MST: -7 * 60,
  PDT: -7 * 60,
  PST: -8 * 60
};
function Mn(t) {
  var e, n, r = t._i, i = ki.exec(r) || Di.exec(r), s, a, o, c, h = Vt.length, p = ye.length;
  if (i) {
    for (v(t).iso = !0, e = 0, n = h; e < n; e++)
      if (Vt[e][1].exec(i[1])) {
        a = Vt[e][0], s = Vt[e][2] !== !1;
        break;
      }
    if (a == null) {
      t._isValid = !1;
      return;
    }
    if (i[3]) {
      for (e = 0, n = p; e < n; e++)
        if (ye[e][1].exec(i[3])) {
          o = (i[2] || " ") + ye[e][0];
          break;
        }
      if (o == null) {
        t._isValid = !1;
        return;
      }
    }
    if (!s && o != null) {
      t._isValid = !1;
      return;
    }
    if (i[4])
      if (bi.exec(i[4]))
        c = "Z";
      else {
        t._isValid = !1;
        return;
      }
    t._f = a + (o || "") + (c || ""), He(t);
  } else
    t._isValid = !1;
}
function xi(t, e, n, r, i, s) {
  var a = [
    Ni(t),
    dn.indexOf(e),
    parseInt(n, 10),
    parseInt(r, 10),
    parseInt(i, 10)
  ];
  return s && a.push(parseInt(s, 10)), a;
}
function Ni(t) {
  var e = parseInt(t, 10);
  return e <= 49 ? 2e3 + e : e <= 999 ? 1900 + e : e;
}
function Ri(t) {
  return t.replace(/\([^()]*\)|[\n\t]/g, " ").replace(/(\s\s+)/g, " ").replace(/^\s\s*/, "").replace(/\s\s*$/, "");
}
function Pi(t, e, n) {
  if (t) {
    var r = pn.indexOf(t), i = new Date(
      e[0],
      e[1],
      e[2]
    ).getDay();
    if (r !== i)
      return v(n).weekdayMismatch = !0, n._isValid = !1, !1;
  }
  return !0;
}
function Ei(t, e, n) {
  if (t)
    return Ti[t];
  if (e)
    return 0;
  var r = parseInt(n, 10), i = r % 100, s = (r - i) / 100;
  return s * 60 + i;
}
function kn(t) {
  var e = Oi.exec(Ri(t._i)), n;
  if (e) {
    if (n = xi(
      e[4],
      e[3],
      e[2],
      e[5],
      e[6],
      e[7]
    ), !Pi(e[1], n, t))
      return;
    t._a = n, t._tzm = Ei(e[8], e[9], e[10]), t._d = Pt.apply(null, t._a), t._d.setUTCMinutes(t._d.getUTCMinutes() - t._tzm), v(t).rfc2822 = !0;
  } else
    t._isValid = !1;
}
function Ci(t) {
  var e = Yi.exec(t._i);
  if (e !== null) {
    t._d = /* @__PURE__ */ new Date(+e[1]);
    return;
  }
  if (Mn(t), t._isValid === !1)
    delete t._isValid;
  else
    return;
  if (kn(t), t._isValid === !1)
    delete t._isValid;
  else
    return;
  t._strict ? t._isValid = !1 : l.createFromInputFallback(t);
}
l.createFromInputFallback = z(
  "value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",
  function(t) {
    t._d = /* @__PURE__ */ new Date(t._i + (t._useUTC ? " UTC" : ""));
  }
);
function wt(t, e, n) {
  return t ?? e ?? n;
}
function Wi(t) {
  var e = new Date(l.now());
  return t._useUTC ? [
    e.getUTCFullYear(),
    e.getUTCMonth(),
    e.getUTCDate()
  ] : [e.getFullYear(), e.getMonth(), e.getDate()];
}
function Ue(t) {
  var e, n, r = [], i, s, a;
  if (!t._d) {
    for (i = Wi(t), t._w && t._a[tt] == null && t._a[at] == null && Ai(t), t._dayOfYear != null && (a = wt(t._a[L], i[L]), (t._dayOfYear > Rt(a) || t._dayOfYear === 0) && (v(t)._overflowDayOfYear = !0), n = Pt(a, 0, t._dayOfYear), t._a[at] = n.getUTCMonth(), t._a[tt] = n.getUTCDate()), e = 0; e < 3 && t._a[e] == null; ++e)
      t._a[e] = r[e] = i[e];
    for (; e < 7; e++)
      t._a[e] = r[e] = t._a[e] == null ? e === 2 ? 1 : 0 : t._a[e];
    t._a[W] === 24 && t._a[B] === 0 && t._a[ot] === 0 && t._a[yt] === 0 && (t._nextDay = !0, t._a[W] = 0), t._d = (t._useUTC ? Pt : Gr).apply(
      null,
      r
    ), s = t._useUTC ? t._d.getUTCDay() : t._d.getDay(), t._tzm != null && t._d.setUTCMinutes(t._d.getUTCMinutes() - t._tzm), t._nextDay && (t._a[W] = 24), t._w && typeof t._w.d < "u" && t._w.d !== s && (v(t).weekdayMismatch = !0);
  }
}
function Ai(t) {
  var e, n, r, i, s, a, o, c, h;
  e = t._w, e.GG != null || e.W != null || e.E != null ? (s = 1, a = 4, n = wt(
    e.GG,
    t._a[L],
    Et(N(), 1, 4).year
  ), r = wt(e.W, 1), i = wt(e.E, 1), (i < 1 || i > 7) && (c = !0)) : (s = t._locale._week.dow, a = t._locale._week.doy, h = Et(N(), s, a), n = wt(e.gg, t._a[L], h.year), r = wt(e.w, h.week), e.d != null ? (i = e.d, (i < 0 || i > 6) && (c = !0)) : e.e != null ? (i = e.e + s, (e.e < 0 || e.e > 6) && (c = !0)) : i = s), r < 1 || r > ut(n, s, a) ? v(t)._overflowWeeks = !0 : c != null ? v(t)._overflowWeekday = !0 : (o = gn(n, r, i, s, a), t._a[L] = o.year, t._dayOfYear = o.dayOfYear);
}
l.ISO_8601 = function() {
};
l.RFC_2822 = function() {
};
function He(t) {
  if (t._f === l.ISO_8601) {
    Mn(t);
    return;
  }
  if (t._f === l.RFC_2822) {
    kn(t);
    return;
  }
  t._a = [], v(t).empty = !0;
  var e = "" + t._i, n, r, i, s, a, o = e.length, c = 0, h, p;
  for (i = rn(t._f, t._locale).match(Ne) || [], p = i.length, n = 0; n < p; n++)
    s = i[n], r = (e.match(br(s, t)) || [])[0], r && (a = e.substr(0, e.indexOf(r)), a.length > 0 && v(t).unusedInput.push(a), e = e.slice(
      e.indexOf(r) + r.length
    ), c += r.length), Mt[s] ? (r ? v(t).empty = !1 : v(t).unusedTokens.push(s), Or(s, r, t)) : t._strict && !r && v(t).unusedTokens.push(s);
  v(t).charsLeftOver = o - c, e.length > 0 && v(t).unusedInput.push(e), t._a[W] <= 12 && v(t).bigHour === !0 && t._a[W] > 0 && (v(t).bigHour = void 0), v(t).parsedDateParts = t._a.slice(0), v(t).meridiem = t._meridiem, t._a[W] = Li(
    t._locale,
    t._a[W],
    t._meridiem
  ), h = v(t).era, h !== null && (t._a[L] = t._locale.erasConvertYear(h, t._a[L])), Ue(t), Fe(t);
}
function Li(t, e, n) {
  var r;
  return n == null ? e : t.meridiemHour != null ? t.meridiemHour(e, n) : (t.isPM != null && (r = t.isPM(n), r && e < 12 && (e += 12), !r && e === 12 && (e = 0)), e);
}
function Fi(t) {
  var e, n, r, i, s, a, o = !1, c = t._f.length;
  if (c === 0) {
    v(t).invalidFormat = !0, t._d = /* @__PURE__ */ new Date(NaN);
    return;
  }
  for (i = 0; i < c; i++)
    s = 0, a = !1, e = Te({}, t), t._useUTC != null && (e._useUTC = t._useUTC), e._f = t._f[i], He(e), Oe(e) && (a = !0), s += v(e).charsLeftOver, s += v(e).unusedTokens.length * 10, v(e).score = s, o ? s < r && (r = s, n = e) : (r == null || s < r || a) && (r = s, n = e, a && (o = !0));
  ht(t, n || e);
}
function Ui(t) {
  if (!t._d) {
    var e = Re(t._i), n = e.day === void 0 ? e.date : e.day;
    t._a = tn(
      [e.year, e.month, n, e.hour, e.minute, e.second, e.millisecond],
      function(r) {
        return r && parseInt(r, 10);
      }
    ), Ue(t);
  }
}
function Hi(t) {
  var e = new At(Fe(Dn(t)));
  return e._nextDay && (e.add(1, "d"), e._nextDay = void 0), e;
}
function Dn(t) {
  var e = t._i, n = t._f;
  return t._locale = t._locale || ct(t._l), e === null || n === void 0 && e === "" ? Kt({ nullInput: !0 }) : (typeof e == "string" && (t._i = e = t._locale.preparse(e)), Q(e) ? new At(Fe(e)) : (Wt(e) ? t._d = e : J(n) ? Fi(t) : n ? He(t) : Ii(t), Oe(t) || (t._d = null), t));
}
function Ii(t) {
  var e = t._i;
  H(e) ? t._d = new Date(l.now()) : Wt(e) ? t._d = new Date(e.valueOf()) : typeof e == "string" ? Ci(t) : J(e) ? (t._a = tn(e.slice(0), function(n) {
    return parseInt(n, 10);
  }), Ue(t)) : gt(e) ? Ui(t) : lt(e) ? t._d = new Date(e) : l.createFromInputFallback(t);
}
function bn(t, e, n, r, i) {
  var s = {};
  return (e === !0 || e === !1) && (r = e, e = void 0), (n === !0 || n === !1) && (r = n, n = void 0), (gt(t) && Ye(t) || J(t) && t.length === 0) && (t = void 0), s._isAMomentObject = !0, s._useUTC = s._isUTC = i, s._l = n, s._i = t, s._f = e, s._strict = r, Hi(s);
}
function N(t, e, n, r) {
  return bn(t, e, n, r, !1);
}
var Gi = z(
  "moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",
  function() {
    var t = N.apply(null, arguments);
    return this.isValid() && t.isValid() ? t < this ? this : t : Kt();
  }
), Vi = z(
  "moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",
  function() {
    var t = N.apply(null, arguments);
    return this.isValid() && t.isValid() ? t > this ? this : t : Kt();
  }
);
function Yn(t, e) {
  var n, r;
  if (e.length === 1 && J(e[0]) && (e = e[0]), !e.length)
    return N();
  for (n = e[0], r = 1; r < e.length; ++r)
    (!e[r].isValid() || e[r][t](n)) && (n = e[r]);
  return n;
}
function ji() {
  var t = [].slice.call(arguments, 0);
  return Yn("isBefore", t);
}
function $i() {
  var t = [].slice.call(arguments, 0);
  return Yn("isAfter", t);
}
var zi = function() {
  return Date.now ? Date.now() : +/* @__PURE__ */ new Date();
}, xt = [
  "year",
  "quarter",
  "month",
  "week",
  "day",
  "hour",
  "minute",
  "second",
  "millisecond"
];
function Zi(t) {
  var e, n = !1, r, i = xt.length;
  for (e in t)
    if (M(t, e) && !(E.call(xt, e) !== -1 && (t[e] == null || !isNaN(t[e]))))
      return !1;
  for (r = 0; r < i; ++r)
    if (t[xt[r]]) {
      if (n)
        return !1;
      parseFloat(t[xt[r]]) !== w(t[xt[r]]) && (n = !0);
    }
  return !0;
}
function qi() {
  return this._isValid;
}
function Bi() {
  return X(NaN);
}
function ue(t) {
  var e = Re(t), n = e.year || 0, r = e.quarter || 0, i = e.month || 0, s = e.week || e.isoWeek || 0, a = e.day || 0, o = e.hour || 0, c = e.minute || 0, h = e.second || 0, p = e.millisecond || 0;
  this._isValid = Zi(e), this._milliseconds = +p + h * 1e3 + // 1000
  c * 6e4 + // 1000 * 60
  o * 1e3 * 60 * 60, this._days = +a + s * 7, this._months = +i + r * 3 + n * 12, this._data = {}, this._locale = ct(), this._bubble();
}
function $t(t) {
  return t instanceof ue;
}
function ke(t) {
  return t < 0 ? Math.round(-1 * t) * -1 : Math.round(t);
}
function Ji(t, e, n) {
  var r = Math.min(t.length, e.length), i = Math.abs(t.length - e.length), s = 0, a;
  for (a = 0; a < r; a++)
    (n && t[a] !== e[a] || !n && w(t[a]) !== w(e[a])) && s++;
  return s + i;
}
function On(t, e) {
  m(t, 0, 0, function() {
    var n = this.utcOffset(), r = "+";
    return n < 0 && (n = -n, r = "-"), r + et(~~(n / 60), 2) + e + et(~~n % 60, 2);
  });
}
On("Z", ":");
On("ZZ", "");
d("Z", se);
d("ZZ", se);
O(["Z", "ZZ"], function(t, e, n) {
  n._useUTC = !0, n._tzm = Ie(se, t);
});
var Qi = /([\+\-]|\d\d)/gi;
function Ie(t, e) {
  var n = (e || "").match(t), r, i, s;
  return n === null ? null : (r = n[n.length - 1] || [], i = (r + "").match(Qi) || ["-", 0, 0], s = +(i[1] * 60) + w(i[2]), s === 0 ? 0 : i[0] === "+" ? s : -s);
}
function Ge(t, e) {
  var n, r;
  return e._isUTC ? (n = e.clone(), r = (Q(t) || Wt(t) ? t.valueOf() : N(t).valueOf()) - n.valueOf(), n._d.setTime(n._d.valueOf() + r), l.updateOffset(n, !1), n) : N(t).local();
}
function De(t) {
  return -Math.round(t._d.getTimezoneOffset());
}
l.updateOffset = function() {
};
function Xi(t, e, n) {
  var r = this._offset || 0, i;
  if (!this.isValid())
    return t != null ? this : NaN;
  if (t != null) {
    if (typeof t == "string") {
      if (t = Ie(se, t), t === null)
        return this;
    } else
      Math.abs(t) < 16 && !n && (t = t * 60);
    return !this._isUTC && e && (i = De(this)), this._offset = t, this._isUTC = !0, i != null && this.add(i, "m"), r !== t && (!e || this._changeInProgress ? Nn(
      this,
      X(t - r, "m"),
      1,
      !1
    ) : this._changeInProgress || (this._changeInProgress = !0, l.updateOffset(this, !0), this._changeInProgress = null)), this;
  } else
    return this._isUTC ? r : De(this);
}
function Ki(t, e) {
  return t != null ? (typeof t != "string" && (t = -t), this.utcOffset(t, e), this) : -this.utcOffset();
}
function ts(t) {
  return this.utcOffset(0, t);
}
function es(t) {
  return this._isUTC && (this.utcOffset(0, t), this._isUTC = !1, t && this.subtract(De(this), "m")), this;
}
function ns() {
  if (this._tzm != null)
    this.utcOffset(this._tzm, !1, !0);
  else if (typeof this._i == "string") {
    var t = Ie(kr, this._i);
    t != null ? this.utcOffset(t) : this.utcOffset(0, !0);
  }
  return this;
}
function rs(t) {
  return this.isValid() ? (t = t ? N(t).utcOffset() : 0, (this.utcOffset() - t) % 60 === 0) : !1;
}
function is() {
  return this.utcOffset() > this.clone().month(0).utcOffset() || this.utcOffset() > this.clone().month(5).utcOffset();
}
function ss() {
  if (!H(this._isDSTShifted))
    return this._isDSTShifted;
  var t = {}, e;
  return Te(t, this), t = Dn(t), t._a ? (e = t._isUTC ? nt(t._a) : N(t._a), this._isDSTShifted = this.isValid() && Ji(t._a, e.toArray()) > 0) : this._isDSTShifted = !1, this._isDSTShifted;
}
function as() {
  return this.isValid() ? !this._isUTC : !1;
}
function os() {
  return this.isValid() ? this._isUTC : !1;
}
function Tn() {
  return this.isValid() ? this._isUTC && this._offset === 0 : !1;
}
var us = /^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/, ls = /^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;
function X(t, e) {
  var n = t, r = null, i, s, a;
  return $t(t) ? n = {
    ms: t._milliseconds,
    d: t._days,
    M: t._months
  } : lt(t) || !isNaN(+t) ? (n = {}, e ? n[e] = +t : n.milliseconds = +t) : (r = us.exec(t)) ? (i = r[1] === "-" ? -1 : 1, n = {
    y: 0,
    d: w(r[tt]) * i,
    h: w(r[W]) * i,
    m: w(r[B]) * i,
    s: w(r[ot]) * i,
    ms: w(ke(r[yt] * 1e3)) * i
    // the millisecond decimal point is included in the match
  }) : (r = ls.exec(t)) ? (i = r[1] === "-" ? -1 : 1, n = {
    y: _t(r[2], i),
    M: _t(r[3], i),
    w: _t(r[4], i),
    d: _t(r[5], i),
    h: _t(r[6], i),
    m: _t(r[7], i),
    s: _t(r[8], i)
  }) : n == null ? n = {} : typeof n == "object" && ("from" in n || "to" in n) && (a = cs(
    N(n.from),
    N(n.to)
  ), n = {}, n.ms = a.milliseconds, n.M = a.months), s = new ue(n), $t(t) && M(t, "_locale") && (s._locale = t._locale), $t(t) && M(t, "_isValid") && (s._isValid = t._isValid), s;
}
X.fn = ue.prototype;
X.invalid = Bi;
function _t(t, e) {
  var n = t && parseFloat(t.replace(",", "."));
  return (isNaN(n) ? 0 : n) * e;
}
function Qe(t, e) {
  var n = {};
  return n.months = e.month() - t.month() + (e.year() - t.year()) * 12, t.clone().add(n.months, "M").isAfter(e) && --n.months, n.milliseconds = +e - +t.clone().add(n.months, "M"), n;
}
function cs(t, e) {
  var n;
  return t.isValid() && e.isValid() ? (e = Ge(e, t), t.isBefore(e) ? n = Qe(t, e) : (n = Qe(e, t), n.milliseconds = -n.milliseconds, n.months = -n.months), n) : { milliseconds: 0, months: 0 };
}
function xn(t, e) {
  return function(n, r) {
    var i, s;
    return r !== null && !isNaN(+r) && (nn(
      e,
      "moment()." + e + "(period, number) is deprecated. Please use moment()." + e + "(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."
    ), s = n, n = r, r = s), i = X(n, r), Nn(this, i, t), this;
  };
}
function Nn(t, e, n, r) {
  var i = e._milliseconds, s = ke(e._days), a = ke(e._months);
  t.isValid() && (r = r ?? !0, a && fn(t, Zt(t, "Month") + a * n), s && an(t, "Date", Zt(t, "Date") + s * n), i && t._d.setTime(t._d.valueOf() + i * n), r && l.updateOffset(t, s || a));
}
var ds = xn(1, "add"), hs = xn(-1, "subtract");
function Rn(t) {
  return typeof t == "string" || t instanceof String;
}
function fs(t) {
  return Q(t) || Wt(t) || Rn(t) || lt(t) || _s(t) || ms(t) || t === null || t === void 0;
}
function ms(t) {
  var e = gt(t) && !Ye(t), n = !1, r = [
    "years",
    "year",
    "y",
    "months",
    "month",
    "M",
    "days",
    "day",
    "d",
    "dates",
    "date",
    "D",
    "hours",
    "hour",
    "h",
    "minutes",
    "minute",
    "m",
    "seconds",
    "second",
    "s",
    "milliseconds",
    "millisecond",
    "ms"
  ], i, s, a = r.length;
  for (i = 0; i < a; i += 1)
    s = r[i], n = n || M(t, s);
  return e && n;
}
function _s(t) {
  var e = J(t), n = !1;
  return e && (n = t.filter(function(r) {
    return !lt(r) && Rn(t);
  }).length === 0), e && n;
}
function ys(t) {
  var e = gt(t) && !Ye(t), n = !1, r = [
    "sameDay",
    "nextDay",
    "lastDay",
    "nextWeek",
    "lastWeek",
    "sameElse"
  ], i, s;
  for (i = 0; i < r.length; i += 1)
    s = r[i], n = n || M(t, s);
  return e && n;
}
function gs(t, e) {
  var n = t.diff(e, "days", !0);
  return n < -6 ? "sameElse" : n < -1 ? "lastWeek" : n < 0 ? "lastDay" : n < 1 ? "sameDay" : n < 2 ? "nextDay" : n < 7 ? "nextWeek" : "sameElse";
}
function ps(t, e) {
  arguments.length === 1 && (arguments[0] ? fs(arguments[0]) ? (t = arguments[0], e = void 0) : ys(arguments[0]) && (e = arguments[0], t = void 0) : (t = void 0, e = void 0));
  var n = t || N(), r = Ge(n, this).startOf("day"), i = l.calendarFormat(this, r) || "sameElse", s = e && (rt(e[i]) ? e[i].call(this, n) : e[i]);
  return this.format(
    s || this.localeData().calendar(i, this, N(n))
  );
}
function vs() {
  return new At(this);
}
function ws(t, e) {
  var n = Q(t) ? t : N(t);
  return this.isValid() && n.isValid() ? (e = Z(e) || "millisecond", e === "millisecond" ? this.valueOf() > n.valueOf() : n.valueOf() < this.clone().startOf(e).valueOf()) : !1;
}
function Ss(t, e) {
  var n = Q(t) ? t : N(t);
  return this.isValid() && n.isValid() ? (e = Z(e) || "millisecond", e === "millisecond" ? this.valueOf() < n.valueOf() : this.clone().endOf(e).valueOf() < n.valueOf()) : !1;
}
function Ms(t, e, n, r) {
  var i = Q(t) ? t : N(t), s = Q(e) ? e : N(e);
  return this.isValid() && i.isValid() && s.isValid() ? (r = r || "()", (r[0] === "(" ? this.isAfter(i, n) : !this.isBefore(i, n)) && (r[1] === ")" ? this.isBefore(s, n) : !this.isAfter(s, n))) : !1;
}
function ks(t, e) {
  var n = Q(t) ? t : N(t), r;
  return this.isValid() && n.isValid() ? (e = Z(e) || "millisecond", e === "millisecond" ? this.valueOf() === n.valueOf() : (r = n.valueOf(), this.clone().startOf(e).valueOf() <= r && r <= this.clone().endOf(e).valueOf())) : !1;
}
function Ds(t, e) {
  return this.isSame(t, e) || this.isAfter(t, e);
}
function bs(t, e) {
  return this.isSame(t, e) || this.isBefore(t, e);
}
function Ys(t, e, n) {
  var r, i, s;
  if (!this.isValid())
    return NaN;
  if (r = Ge(t, this), !r.isValid())
    return NaN;
  switch (i = (r.utcOffset() - this.utcOffset()) * 6e4, e = Z(e), e) {
    case "year":
      s = zt(this, r) / 12;
      break;
    case "month":
      s = zt(this, r);
      break;
    case "quarter":
      s = zt(this, r) / 3;
      break;
    case "second":
      s = (this - r) / 1e3;
      break;
    case "minute":
      s = (this - r) / 6e4;
      break;
    case "hour":
      s = (this - r) / 36e5;
      break;
    case "day":
      s = (this - r - i) / 864e5;
      break;
    case "week":
      s = (this - r - i) / 6048e5;
      break;
    default:
      s = this - r;
  }
  return n ? s : $(s);
}
function zt(t, e) {
  if (t.date() < e.date())
    return -zt(e, t);
  var n = (e.year() - t.year()) * 12 + (e.month() - t.month()), r = t.clone().add(n, "months"), i, s;
  return e - r < 0 ? (i = t.clone().add(n - 1, "months"), s = (e - r) / (r - i)) : (i = t.clone().add(n + 1, "months"), s = (e - r) / (i - r)), -(n + s) || 0;
}
l.defaultFormat = "YYYY-MM-DDTHH:mm:ssZ";
l.defaultFormatUtc = "YYYY-MM-DDTHH:mm:ss[Z]";
function Os() {
  return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ");
}
function Ts(t) {
  if (!this.isValid())
    return null;
  var e = t !== !0, n = e ? this.clone().utc() : this;
  return n.year() < 0 || n.year() > 9999 ? jt(
    n,
    e ? "YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"
  ) : rt(Date.prototype.toISOString) ? e ? this.toDate().toISOString() : new Date(this.valueOf() + this.utcOffset() * 60 * 1e3).toISOString().replace("Z", jt(n, "Z")) : jt(
    n,
    e ? "YYYY-MM-DD[T]HH:mm:ss.SSS[Z]" : "YYYY-MM-DD[T]HH:mm:ss.SSSZ"
  );
}
function xs() {
  if (!this.isValid())
    return "moment.invalid(/* " + this._i + " */)";
  var t = "moment", e = "", n, r, i, s;
  return this.isLocal() || (t = this.utcOffset() === 0 ? "moment.utc" : "moment.parseZone", e = "Z"), n = "[" + t + '("]', r = 0 <= this.year() && this.year() <= 9999 ? "YYYY" : "YYYYYY", i = "-MM-DD[T]HH:mm:ss.SSS", s = e + '[")]', this.format(n + r + i + s);
}
function Ns(t) {
  t || (t = this.isUtc() ? l.defaultFormatUtc : l.defaultFormat);
  var e = jt(this, t);
  return this.localeData().postformat(e);
}
function Rs(t, e) {
  return this.isValid() && (Q(t) && t.isValid() || N(t).isValid()) ? X({ to: this, from: t }).locale(this.locale()).humanize(!e) : this.localeData().invalidDate();
}
function Ps(t) {
  return this.from(N(), t);
}
function Es(t, e) {
  return this.isValid() && (Q(t) && t.isValid() || N(t).isValid()) ? X({ from: this, to: t }).locale(this.locale()).humanize(!e) : this.localeData().invalidDate();
}
function Cs(t) {
  return this.to(N(), t);
}
function Pn(t) {
  var e;
  return t === void 0 ? this._locale._abbr : (e = ct(t), e != null && (this._locale = e), this);
}
var En = z(
  "moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",
  function(t) {
    return t === void 0 ? this.localeData() : this.locale(t);
  }
);
function Cn() {
  return this._locale;
}
var Jt = 1e3, kt = 60 * Jt, Qt = 60 * kt, Wn = (365 * 400 + 97) * 24 * Qt;
function Dt(t, e) {
  return (t % e + e) % e;
}
function An(t, e, n) {
  return t < 100 && t >= 0 ? new Date(t + 400, e, n) - Wn : new Date(t, e, n).valueOf();
}
function Ln(t, e, n) {
  return t < 100 && t >= 0 ? Date.UTC(t + 400, e, n) - Wn : Date.UTC(t, e, n);
}
function Ws(t) {
  var e, n;
  if (t = Z(t), t === void 0 || t === "millisecond" || !this.isValid())
    return this;
  switch (n = this._isUTC ? Ln : An, t) {
    case "year":
      e = n(this.year(), 0, 1);
      break;
    case "quarter":
      e = n(
        this.year(),
        this.month() - this.month() % 3,
        1
      );
      break;
    case "month":
      e = n(this.year(), this.month(), 1);
      break;
    case "week":
      e = n(
        this.year(),
        this.month(),
        this.date() - this.weekday()
      );
      break;
    case "isoWeek":
      e = n(
        this.year(),
        this.month(),
        this.date() - (this.isoWeekday() - 1)
      );
      break;
    case "day":
    case "date":
      e = n(this.year(), this.month(), this.date());
      break;
    case "hour":
      e = this._d.valueOf(), e -= Dt(
        e + (this._isUTC ? 0 : this.utcOffset() * kt),
        Qt
      );
      break;
    case "minute":
      e = this._d.valueOf(), e -= Dt(e, kt);
      break;
    case "second":
      e = this._d.valueOf(), e -= Dt(e, Jt);
      break;
  }
  return this._d.setTime(e), l.updateOffset(this, !0), this;
}
function As(t) {
  var e, n;
  if (t = Z(t), t === void 0 || t === "millisecond" || !this.isValid())
    return this;
  switch (n = this._isUTC ? Ln : An, t) {
    case "year":
      e = n(this.year() + 1, 0, 1) - 1;
      break;
    case "quarter":
      e = n(
        this.year(),
        this.month() - this.month() % 3 + 3,
        1
      ) - 1;
      break;
    case "month":
      e = n(this.year(), this.month() + 1, 1) - 1;
      break;
    case "week":
      e = n(
        this.year(),
        this.month(),
        this.date() - this.weekday() + 7
      ) - 1;
      break;
    case "isoWeek":
      e = n(
        this.year(),
        this.month(),
        this.date() - (this.isoWeekday() - 1) + 7
      ) - 1;
      break;
    case "day":
    case "date":
      e = n(this.year(), this.month(), this.date() + 1) - 1;
      break;
    case "hour":
      e = this._d.valueOf(), e += Qt - Dt(
        e + (this._isUTC ? 0 : this.utcOffset() * kt),
        Qt
      ) - 1;
      break;
    case "minute":
      e = this._d.valueOf(), e += kt - Dt(e, kt) - 1;
      break;
    case "second":
      e = this._d.valueOf(), e += Jt - Dt(e, Jt) - 1;
      break;
  }
  return this._d.setTime(e), l.updateOffset(this, !0), this;
}
function Ls() {
  return this._d.valueOf() - (this._offset || 0) * 6e4;
}
function Fs() {
  return Math.floor(this.valueOf() / 1e3);
}
function Us() {
  return new Date(this.valueOf());
}
function Hs() {
  var t = this;
  return [
    t.year(),
    t.month(),
    t.date(),
    t.hour(),
    t.minute(),
    t.second(),
    t.millisecond()
  ];
}
function Is() {
  var t = this;
  return {
    years: t.year(),
    months: t.month(),
    date: t.date(),
    hours: t.hours(),
    minutes: t.minutes(),
    seconds: t.seconds(),
    milliseconds: t.milliseconds()
  };
}
function Gs() {
  return this.isValid() ? this.toISOString() : null;
}
function Vs() {
  return Oe(this);
}
function js() {
  return ht({}, v(this));
}
function $s() {
  return v(this).overflow;
}
function zs() {
  return {
    input: this._i,
    format: this._f,
    locale: this._locale,
    isUTC: this._isUTC,
    strict: this._strict
  };
}
m("N", 0, 0, "eraAbbr");
m("NN", 0, 0, "eraAbbr");
m("NNN", 0, 0, "eraAbbr");
m("NNNN", 0, 0, "eraName");
m("NNNNN", 0, 0, "eraNarrow");
m("y", ["y", 1], "yo", "eraYear");
m("y", ["yy", 2], 0, "eraYear");
m("y", ["yyy", 3], 0, "eraYear");
m("y", ["yyyy", 4], 0, "eraYear");
d("N", Ve);
d("NN", Ve);
d("NNN", Ve);
d("NNNN", ra);
d("NNNNN", ia);
O(
  ["N", "NN", "NNN", "NNNN", "NNNNN"],
  function(t, e, n, r) {
    var i = n._locale.erasParse(t, r, n._strict);
    i ? v(n).era = i : v(n).invalidEra = t;
  }
);
d("y", Yt);
d("yy", Yt);
d("yyy", Yt);
d("yyyy", Yt);
d("yo", sa);
O(["y", "yy", "yyy", "yyyy"], L);
O(["yo"], function(t, e, n, r) {
  var i;
  n._locale._eraYearOrdinalRegex && (i = t.match(n._locale._eraYearOrdinalRegex)), n._locale.eraYearOrdinalParse ? e[L] = n._locale.eraYearOrdinalParse(t, i) : e[L] = parseInt(t, 10);
});
function Zs(t, e) {
  var n, r, i, s = this._eras || ct("en")._eras;
  for (n = 0, r = s.length; n < r; ++n) {
    switch (typeof s[n].since) {
      case "string":
        i = l(s[n].since).startOf("day"), s[n].since = i.valueOf();
        break;
    }
    switch (typeof s[n].until) {
      case "undefined":
        s[n].until = 1 / 0;
        break;
      case "string":
        i = l(s[n].until).startOf("day").valueOf(), s[n].until = i.valueOf();
        break;
    }
  }
  return s;
}
function qs(t, e, n) {
  var r, i, s = this.eras(), a, o, c;
  for (t = t.toUpperCase(), r = 0, i = s.length; r < i; ++r)
    if (a = s[r].name.toUpperCase(), o = s[r].abbr.toUpperCase(), c = s[r].narrow.toUpperCase(), n)
      switch (e) {
        case "N":
        case "NN":
        case "NNN":
          if (o === t)
            return s[r];
          break;
        case "NNNN":
          if (a === t)
            return s[r];
          break;
        case "NNNNN":
          if (c === t)
            return s[r];
          break;
      }
    else if ([a, o, c].indexOf(t) >= 0)
      return s[r];
}
function Bs(t, e) {
  var n = t.since <= t.until ? 1 : -1;
  return e === void 0 ? l(t.since).year() : l(t.since).year() + (e - t.offset) * n;
}
function Js() {
  var t, e, n, r = this.localeData().eras();
  for (t = 0, e = r.length; t < e; ++t)
    if (n = this.clone().startOf("day").valueOf(), r[t].since <= n && n <= r[t].until || r[t].until <= n && n <= r[t].since)
      return r[t].name;
  return "";
}
function Qs() {
  var t, e, n, r = this.localeData().eras();
  for (t = 0, e = r.length; t < e; ++t)
    if (n = this.clone().startOf("day").valueOf(), r[t].since <= n && n <= r[t].until || r[t].until <= n && n <= r[t].since)
      return r[t].narrow;
  return "";
}
function Xs() {
  var t, e, n, r = this.localeData().eras();
  for (t = 0, e = r.length; t < e; ++t)
    if (n = this.clone().startOf("day").valueOf(), r[t].since <= n && n <= r[t].until || r[t].until <= n && n <= r[t].since)
      return r[t].abbr;
  return "";
}
function Ks() {
  var t, e, n, r, i = this.localeData().eras();
  for (t = 0, e = i.length; t < e; ++t)
    if (n = i[t].since <= i[t].until ? 1 : -1, r = this.clone().startOf("day").valueOf(), i[t].since <= r && r <= i[t].until || i[t].until <= r && r <= i[t].since)
      return (this.year() - l(i[t].since).year()) * n + i[t].offset;
  return this.year();
}
function ta(t) {
  return M(this, "_erasNameRegex") || je.call(this), t ? this._erasNameRegex : this._erasRegex;
}
function ea(t) {
  return M(this, "_erasAbbrRegex") || je.call(this), t ? this._erasAbbrRegex : this._erasRegex;
}
function na(t) {
  return M(this, "_erasNarrowRegex") || je.call(this), t ? this._erasNarrowRegex : this._erasRegex;
}
function Ve(t, e) {
  return e.erasAbbrRegex(t);
}
function ra(t, e) {
  return e.erasNameRegex(t);
}
function ia(t, e) {
  return e.erasNarrowRegex(t);
}
function sa(t, e) {
  return e._eraYearOrdinalRegex || Yt;
}
function je() {
  var t = [], e = [], n = [], r = [], i, s, a = this.eras();
  for (i = 0, s = a.length; i < s; ++i)
    e.push(G(a[i].name)), t.push(G(a[i].abbr)), n.push(G(a[i].narrow)), r.push(G(a[i].name)), r.push(G(a[i].abbr)), r.push(G(a[i].narrow));
  this._erasRegex = new RegExp("^(" + r.join("|") + ")", "i"), this._erasNameRegex = new RegExp("^(" + e.join("|") + ")", "i"), this._erasAbbrRegex = new RegExp("^(" + t.join("|") + ")", "i"), this._erasNarrowRegex = new RegExp(
    "^(" + n.join("|") + ")",
    "i"
  );
}
m(0, ["gg", 2], 0, function() {
  return this.weekYear() % 100;
});
m(0, ["GG", 2], 0, function() {
  return this.isoWeekYear() % 100;
});
function le(t, e) {
  m(0, [t, t.length], 0, e);
}
le("gggg", "weekYear");
le("ggggg", "weekYear");
le("GGGG", "isoWeekYear");
le("GGGGG", "isoWeekYear");
F("weekYear", "gg");
F("isoWeekYear", "GG");
U("weekYear", 1);
U("isoWeekYear", 1);
d("G", ie);
d("g", ie);
d("GG", R, V);
d("gg", R, V);
d("GGGG", Ee, Pe);
d("gggg", Ee, Pe);
d("GGGGG", re, ee);
d("ggggg", re, ee);
Ft(
  ["gggg", "ggggg", "GGGG", "GGGGG"],
  function(t, e, n, r) {
    e[r.substr(0, 2)] = w(t);
  }
);
Ft(["gg", "GG"], function(t, e, n, r) {
  e[r] = l.parseTwoDigitYear(t);
});
function aa(t) {
  return Fn.call(
    this,
    t,
    this.week(),
    this.weekday(),
    this.localeData()._week.dow,
    this.localeData()._week.doy
  );
}
function oa(t) {
  return Fn.call(
    this,
    t,
    this.isoWeek(),
    this.isoWeekday(),
    1,
    4
  );
}
function ua() {
  return ut(this.year(), 1, 4);
}
function la() {
  return ut(this.isoWeekYear(), 1, 4);
}
function ca() {
  var t = this.localeData()._week;
  return ut(this.year(), t.dow, t.doy);
}
function da() {
  var t = this.localeData()._week;
  return ut(this.weekYear(), t.dow, t.doy);
}
function Fn(t, e, n, r, i) {
  var s;
  return t == null ? Et(this, r, i).year : (s = ut(t, r, i), e > s && (e = s), ha.call(this, t, e, n, r, i));
}
function ha(t, e, n, r, i) {
  var s = gn(t, e, n, r, i), a = Pt(s.year, 0, s.dayOfYear);
  return this.year(a.getUTCFullYear()), this.month(a.getUTCMonth()), this.date(a.getUTCDate()), this;
}
m("Q", 0, "Qo", "quarter");
F("quarter", "Q");
U("quarter", 7);
d("Q", on);
O("Q", function(t, e) {
  e[at] = (w(t) - 1) * 3;
});
function fa(t) {
  return t == null ? Math.ceil((this.month() + 1) / 3) : this.month((t - 1) * 3 + this.month() % 3);
}
m("D", ["DD", 2], "Do", "date");
F("date", "D");
U("date", 9);
d("D", R);
d("DD", R, V);
d("Do", function(t, e) {
  return t ? e._dayOfMonthOrdinalParse || e._ordinalParse : e._dayOfMonthOrdinalParseLenient;
});
O(["D", "DD"], tt);
O("Do", function(t, e) {
  e[tt] = w(t.match(R)[0]);
});
var Un = bt("Date", !0);
m("DDD", ["DDDD", 3], "DDDo", "dayOfYear");
F("dayOfYear", "DDD");
U("dayOfYear", 4);
d("DDD", ne);
d("DDDD", un);
O(["DDD", "DDDD"], function(t, e, n) {
  n._dayOfYear = w(t);
});
function ma(t) {
  var e = Math.round(
    (this.clone().startOf("day") - this.clone().startOf("year")) / 864e5
  ) + 1;
  return t == null ? e : this.add(t - e, "d");
}
m("m", ["mm", 2], 0, "minute");
F("minute", "m");
U("minute", 14);
d("m", R);
d("mm", R, V);
O(["m", "mm"], B);
var _a = bt("Minutes", !1);
m("s", ["ss", 2], 0, "second");
F("second", "s");
U("second", 15);
d("s", R);
d("ss", R, V);
O(["s", "ss"], ot);
var ya = bt("Seconds", !1);
m("S", 0, 0, function() {
  return ~~(this.millisecond() / 100);
});
m(0, ["SS", 2], 0, function() {
  return ~~(this.millisecond() / 10);
});
m(0, ["SSS", 3], 0, "millisecond");
m(0, ["SSSS", 4], 0, function() {
  return this.millisecond() * 10;
});
m(0, ["SSSSS", 5], 0, function() {
  return this.millisecond() * 100;
});
m(0, ["SSSSSS", 6], 0, function() {
  return this.millisecond() * 1e3;
});
m(0, ["SSSSSSS", 7], 0, function() {
  return this.millisecond() * 1e4;
});
m(0, ["SSSSSSSS", 8], 0, function() {
  return this.millisecond() * 1e5;
});
m(0, ["SSSSSSSSS", 9], 0, function() {
  return this.millisecond() * 1e6;
});
F("millisecond", "ms");
U("millisecond", 16);
d("S", ne, on);
d("SS", ne, V);
d("SSS", ne, un);
var ft, Hn;
for (ft = "SSSS"; ft.length <= 9; ft += "S")
  d(ft, Yt);
function ga(t, e) {
  e[yt] = w(("0." + t) * 1e3);
}
for (ft = "S"; ft.length <= 9; ft += "S")
  O(ft, ga);
Hn = bt("Milliseconds", !1);
m("z", 0, 0, "zoneAbbr");
m("zz", 0, 0, "zoneName");
function pa() {
  return this._isUTC ? "UTC" : "";
}
function va() {
  return this._isUTC ? "Coordinated Universal Time" : "";
}
var u = At.prototype;
u.add = ds;
u.calendar = ps;
u.clone = vs;
u.diff = Ys;
u.endOf = As;
u.format = Ns;
u.from = Rs;
u.fromNow = Ps;
u.to = Es;
u.toNow = Cs;
u.get = Sr;
u.invalidAt = $s;
u.isAfter = ws;
u.isBefore = Ss;
u.isBetween = Ms;
u.isSame = ks;
u.isSameOrAfter = Ds;
u.isSameOrBefore = bs;
u.isValid = Vs;
u.lang = En;
u.locale = Pn;
u.localeData = Cn;
u.max = Vi;
u.min = Gi;
u.parsingFlags = js;
u.set = Mr;
u.startOf = Ws;
u.subtract = hs;
u.toArray = Hs;
u.toObject = Is;
u.toDate = Us;
u.toISOString = Ts;
u.inspect = xs;
typeof Symbol < "u" && Symbol.for != null && (u[Symbol.for("nodejs.util.inspect.custom")] = function() {
  return "Moment<" + this.format() + ">";
});
u.toJSON = Gs;
u.toString = Os;
u.unix = Fs;
u.valueOf = Ls;
u.creationData = zs;
u.eraName = Js;
u.eraNarrow = Qs;
u.eraAbbr = Xs;
u.eraYear = Ks;
u.year = yn;
u.isLeapYear = Ir;
u.weekYear = aa;
u.isoWeekYear = oa;
u.quarter = u.quarters = fa;
u.month = mn;
u.daysInMonth = Fr;
u.week = u.weeks = Zr;
u.isoWeek = u.isoWeeks = qr;
u.weeksInYear = ca;
u.weeksInWeekYear = da;
u.isoWeeksInYear = ua;
u.isoWeeksInISOWeekYear = la;
u.date = Un;
u.day = u.days = oi;
u.weekday = ui;
u.isoWeekday = li;
u.dayOfYear = ma;
u.hour = u.hours = yi;
u.minute = u.minutes = _a;
u.second = u.seconds = ya;
u.millisecond = u.milliseconds = Hn;
u.utcOffset = Xi;
u.utc = ts;
u.local = es;
u.parseZone = ns;
u.hasAlignedHourOffset = rs;
u.isDST = is;
u.isLocal = as;
u.isUtcOffset = os;
u.isUtc = Tn;
u.isUTC = Tn;
u.zoneAbbr = pa;
u.zoneName = va;
u.dates = z(
  "dates accessor is deprecated. Use date instead.",
  Un
);
u.months = z(
  "months accessor is deprecated. Use month instead",
  mn
);
u.years = z(
  "years accessor is deprecated. Use year instead",
  yn
);
u.zone = z(
  "moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",
  Ki
);
u.isDSTShifted = z(
  "isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",
  ss
);
function wa(t) {
  return N(t * 1e3);
}
function Sa() {
  return N.apply(null, arguments).parseZone();
}
function In(t) {
  return t;
}
var k = xe.prototype;
k.calendar = or;
k.longDateFormat = dr;
k.invalidDate = fr;
k.ordinal = yr;
k.preparse = In;
k.postformat = In;
k.relativeTime = pr;
k.pastFuture = vr;
k.set = sr;
k.eras = Zs;
k.erasParse = qs;
k.erasConvertYear = Bs;
k.erasAbbrRegex = ea;
k.erasNameRegex = ta;
k.erasNarrowRegex = na;
k.months = Cr;
k.monthsShort = Wr;
k.monthsParse = Lr;
k.monthsRegex = Hr;
k.monthsShortRegex = Ur;
k.week = Vr;
k.firstDayOfYear = zr;
k.firstDayOfWeek = $r;
k.weekdays = ni;
k.weekdaysMin = ii;
k.weekdaysShort = ri;
k.weekdaysParse = ai;
k.weekdaysRegex = ci;
k.weekdaysShortRegex = di;
k.weekdaysMinRegex = hi;
k.isPM = mi;
k.meridiem = gi;
function Xt(t, e, n, r) {
  var i = ct(), s = nt().set(r, e);
  return i[n](s, t);
}
function Gn(t, e, n) {
  if (lt(t) && (e = t, t = void 0), t = t || "", e != null)
    return Xt(t, e, n, "month");
  var r, i = [];
  for (r = 0; r < 12; r++)
    i[r] = Xt(t, r, n, "month");
  return i;
}
function $e(t, e, n, r) {
  typeof t == "boolean" ? (lt(e) && (n = e, e = void 0), e = e || "") : (e = t, n = e, t = !1, lt(e) && (n = e, e = void 0), e = e || "");
  var i = ct(), s = t ? i._week.dow : 0, a, o = [];
  if (n != null)
    return Xt(e, (n + s) % 7, r, "day");
  for (a = 0; a < 7; a++)
    o[a] = Xt(e, (a + s) % 7, r, "day");
  return o;
}
function Ma(t, e) {
  return Gn(t, e, "months");
}
function ka(t, e) {
  return Gn(t, e, "monthsShort");
}
function Da(t, e, n) {
  return $e(t, e, n, "weekdays");
}
function ba(t, e, n) {
  return $e(t, e, n, "weekdaysShort");
}
function Ya(t, e, n) {
  return $e(t, e, n, "weekdaysMin");
}
mt("en", {
  eras: [
    {
      since: "0001-01-01",
      until: 1 / 0,
      offset: 1,
      name: "Anno Domini",
      narrow: "AD",
      abbr: "AD"
    },
    {
      since: "0000-12-31",
      until: -1 / 0,
      offset: 1,
      name: "Before Christ",
      narrow: "BC",
      abbr: "BC"
    }
  ],
  dayOfMonthOrdinalParse: /\d{1,2}(th|st|nd|rd)/,
  ordinal: function(t) {
    var e = t % 10, n = w(t % 100 / 10) === 1 ? "th" : e === 1 ? "st" : e === 2 ? "nd" : e === 3 ? "rd" : "th";
    return t + n;
  }
});
l.lang = z(
  "moment.lang is deprecated. Use moment.locale instead.",
  mt
);
l.langData = z(
  "moment.langData is deprecated. Use moment.localeData instead.",
  ct
);
var it = Math.abs;
function Oa() {
  var t = this._data;
  return this._milliseconds = it(this._milliseconds), this._days = it(this._days), this._months = it(this._months), t.milliseconds = it(t.milliseconds), t.seconds = it(t.seconds), t.minutes = it(t.minutes), t.hours = it(t.hours), t.months = it(t.months), t.years = it(t.years), this;
}
function Vn(t, e, n, r) {
  var i = X(e, n);
  return t._milliseconds += r * i._milliseconds, t._days += r * i._days, t._months += r * i._months, t._bubble();
}
function Ta(t, e) {
  return Vn(this, t, e, 1);
}
function xa(t, e) {
  return Vn(this, t, e, -1);
}
function Xe(t) {
  return t < 0 ? Math.floor(t) : Math.ceil(t);
}
function Na() {
  var t = this._milliseconds, e = this._days, n = this._months, r = this._data, i, s, a, o, c;
  return t >= 0 && e >= 0 && n >= 0 || t <= 0 && e <= 0 && n <= 0 || (t += Xe(be(n) + e) * 864e5, e = 0, n = 0), r.milliseconds = t % 1e3, i = $(t / 1e3), r.seconds = i % 60, s = $(i / 60), r.minutes = s % 60, a = $(s / 60), r.hours = a % 24, e += $(a / 24), c = $(jn(e)), n += c, e -= Xe(be(c)), o = $(n / 12), n %= 12, r.days = e, r.months = n, r.years = o, this;
}
function jn(t) {
  return t * 4800 / 146097;
}
function be(t) {
  return t * 146097 / 4800;
}
function Ra(t) {
  if (!this.isValid())
    return NaN;
  var e, n, r = this._milliseconds;
  if (t = Z(t), t === "month" || t === "quarter" || t === "year")
    switch (e = this._days + r / 864e5, n = this._months + jn(e), t) {
      case "month":
        return n;
      case "quarter":
        return n / 3;
      case "year":
        return n / 12;
    }
  else
    switch (e = this._days + Math.round(be(this._months)), t) {
      case "week":
        return e / 7 + r / 6048e5;
      case "day":
        return e + r / 864e5;
      case "hour":
        return e * 24 + r / 36e5;
      case "minute":
        return e * 1440 + r / 6e4;
      case "second":
        return e * 86400 + r / 1e3;
      case "millisecond":
        return Math.floor(e * 864e5) + r;
      default:
        throw new Error("Unknown unit " + t);
    }
}
function Pa() {
  return this.isValid() ? this._milliseconds + this._days * 864e5 + this._months % 12 * 2592e6 + w(this._months / 12) * 31536e6 : NaN;
}
function dt(t) {
  return function() {
    return this.as(t);
  };
}
var Ea = dt("ms"), Ca = dt("s"), Wa = dt("m"), Aa = dt("h"), La = dt("d"), Fa = dt("w"), Ua = dt("M"), Ha = dt("Q"), Ia = dt("y");
function Ga() {
  return X(this);
}
function Va(t) {
  return t = Z(t), this.isValid() ? this[t + "s"]() : NaN;
}
function pt(t) {
  return function() {
    return this.isValid() ? this._data[t] : NaN;
  };
}
var ja = pt("milliseconds"), $a = pt("seconds"), za = pt("minutes"), Za = pt("hours"), qa = pt("days"), Ba = pt("months"), Ja = pt("years");
function Qa() {
  return $(this.days() / 7);
}
var st = Math.round, St = {
  ss: 44,
  // a few seconds to seconds
  s: 45,
  // seconds to minute
  m: 45,
  // minutes to hour
  h: 22,
  // hours to day
  d: 26,
  // days to month/week
  w: null,
  // weeks to month
  M: 11
  // months to year
};
function Xa(t, e, n, r, i) {
  return i.relativeTime(e || 1, !!n, t, r);
}
function Ka(t, e, n, r) {
  var i = X(t).abs(), s = st(i.as("s")), a = st(i.as("m")), o = st(i.as("h")), c = st(i.as("d")), h = st(i.as("M")), p = st(i.as("w")), Y = st(i.as("y")), b = s <= n.ss && ["s", s] || s < n.s && ["ss", s] || a <= 1 && ["m"] || a < n.m && ["mm", a] || o <= 1 && ["h"] || o < n.h && ["hh", o] || c <= 1 && ["d"] || c < n.d && ["dd", c];
  return n.w != null && (b = b || p <= 1 && ["w"] || p < n.w && ["ww", p]), b = b || h <= 1 && ["M"] || h < n.M && ["MM", h] || Y <= 1 && ["y"] || ["yy", Y], b[2] = e, b[3] = +t > 0, b[4] = r, Xa.apply(null, b);
}
function to(t) {
  return t === void 0 ? st : typeof t == "function" ? (st = t, !0) : !1;
}
function eo(t, e) {
  return St[t] === void 0 ? !1 : e === void 0 ? St[t] : (St[t] = e, t === "s" && (St.ss = e - 1), !0);
}
function no(t, e) {
  if (!this.isValid())
    return this.localeData().invalidDate();
  var n = !1, r = St, i, s;
  return typeof t == "object" && (e = t, t = !1), typeof t == "boolean" && (n = t), typeof e == "object" && (r = Object.assign({}, St, e), e.s != null && e.ss == null && (r.ss = e.s - 1)), i = this.localeData(), s = Ka(this, !n, r, i), n && (s = i.pastFuture(+this, s)), i.postformat(s);
}
var ge = Math.abs;
function vt(t) {
  return (t > 0) - (t < 0) || +t;
}
function ce() {
  if (!this.isValid())
    return this.localeData().invalidDate();
  var t = ge(this._milliseconds) / 1e3, e = ge(this._days), n = ge(this._months), r, i, s, a, o = this.asSeconds(), c, h, p, Y;
  return o ? (r = $(t / 60), i = $(r / 60), t %= 60, r %= 60, s = $(n / 12), n %= 12, a = t ? t.toFixed(3).replace(/\.?0+$/, "") : "", c = o < 0 ? "-" : "", h = vt(this._months) !== vt(o) ? "-" : "", p = vt(this._days) !== vt(o) ? "-" : "", Y = vt(this._milliseconds) !== vt(o) ? "-" : "", c + "P" + (s ? h + s + "Y" : "") + (n ? h + n + "M" : "") + (e ? p + e + "D" : "") + (i || r || t ? "T" : "") + (i ? Y + i + "H" : "") + (r ? Y + r + "M" : "") + (t ? Y + a + "S" : "")) : "P0D";
}
var S = ue.prototype;
S.isValid = qi;
S.abs = Oa;
S.add = Ta;
S.subtract = xa;
S.as = Ra;
S.asMilliseconds = Ea;
S.asSeconds = Ca;
S.asMinutes = Wa;
S.asHours = Aa;
S.asDays = La;
S.asWeeks = Fa;
S.asMonths = Ua;
S.asQuarters = Ha;
S.asYears = Ia;
S.valueOf = Pa;
S._bubble = Na;
S.clone = Ga;
S.get = Va;
S.milliseconds = ja;
S.seconds = $a;
S.minutes = za;
S.hours = Za;
S.days = qa;
S.weeks = Qa;
S.months = Ba;
S.years = Ja;
S.humanize = no;
S.toISOString = ce;
S.toString = ce;
S.toJSON = ce;
S.locale = Pn;
S.localeData = Cn;
S.toIsoString = z(
  "toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",
  ce
);
S.lang = En;
m("X", 0, 0, "unix");
m("x", 0, 0, "valueOf");
d("x", ie);
d("X", Dr);
O("X", function(t, e, n) {
  n._d = new Date(parseFloat(t) * 1e3);
});
O("x", function(t, e, n) {
  n._d = new Date(w(t));
});
//! moment.js
l.version = "2.29.4";
rr(N);
l.fn = u;
l.min = ji;
l.max = $i;
l.now = zi;
l.utc = nt;
l.unix = wa;
l.months = Ma;
l.isDate = Wt;
l.locale = mt;
l.invalid = Kt;
l.duration = X;
l.isMoment = Q;
l.weekdays = Da;
l.parseZone = Sa;
l.localeData = ct;
l.isDuration = $t;
l.monthsShort = ka;
l.weekdaysMin = Ya;
l.defineLocale = Le;
l.updateLocale = Si;
l.locales = Mi;
l.weekdaysShort = ba;
l.normalizeUnits = Z;
l.relativeTimeRounding = to;
l.relativeTimeThreshold = eo;
l.calendarFormat = gs;
l.prototype = u;
l.HTML5_FMT = {
  DATETIME_LOCAL: "YYYY-MM-DDTHH:mm",
  // <input type="datetime-local" />
  DATETIME_LOCAL_SECONDS: "YYYY-MM-DDTHH:mm:ss",
  // <input type="datetime-local" step="1" />
  DATETIME_LOCAL_MS: "YYYY-MM-DDTHH:mm:ss.SSS",
  // <input type="datetime-local" step="0.001" />
  DATE: "YYYY-MM-DD",
  // <input type="date" />
  TIME: "HH:mm",
  // <input type="time" />
  TIME_SECONDS: "HH:mm:ss",
  // <input type="time" step="1" />
  TIME_MS: "HH:mm:ss.SSS",
  // <input type="time" step="0.001" />
  WEEK: "GGGG-[W]WW",
  // <input type="week" />
  MONTH: "YYYY-MM"
  // <input type="month" />
};
var ro = Object.defineProperty, io = (t, e, n) => e in t ? ro(t, e, { enumerable: !0, configurable: !0, writable: !0, value: n }) : t[e] = n, q = (t, e, n) => (io(t, typeof e != "symbol" ? e + "" : e, n), n);
const I = class {
  constructor() {
  }
};
q(I, "PAGINATION", {
  ROWS_PER_PAGE: {
    OPTIONS: [10, 20, 30, 50, 100],
    DEFAULT: 20
  }
  //NOTE: Custom Templates are causing an error when switching route to page with paginator
  // TEMPLATE: {
  //   '530px': 'FirstPageLink PrevPageLink NextPageLink LastPageLink',
  //   '600px': 'FirstPageLink PrevPageLink CurrentPageReport NextPageLink LastPageLink',
  //   '640px':
  //     'FirstPageLink PrevPageLink CurrentPageReport RowsPerPageDropdown NextPageLink LastPageLink',
  //   '960px':
  //     'FirstPageLink PrevPageLink CurrentPageReport RowsPerPageDropdown NextPageLink LastPageLink',
  //   default:
  //     'CurrentPageReport FirstPageLink PrevPageLink PageLinks NextPageLink LastPageLink RowsPerPageDropdown'
  // },
  // TEMPLATE_FROM_PRIVEVUE_EXAMPLE: {
  //   '640px': 'PrevPageLink CurrentPageReport NextPageLink',
  //   '960px': 'FirstPageLink PrevPageLink CurrentPageReport NextPageLink LastPageLink',
  //   '1300px': 'FirstPageLink PrevPageLink PageLinks NextPageLink LastPageLink',
  //   default:
  //     'FirstPageLink PrevPageLink PageLinks NextPageLink LastPageLink JumpToPageDropdown JumpToPageInput'
  // },
  // TEMPLATE_MINI: 'PrevPageLink CurrentPageReport NextPageLink RowsPerPageDropdown'
}), q(I, "ISO_DATE_FORMAT_STRING", "yyyy-MM-DD"), q(I, "ISO_TIME_FORMAT_STRING", "HH:mm"), q(I, "ISO_DATE_TIME_FORMAT_STRING", `${I.ISO_DATE_FORMAT_STRING} ${I.ISO_TIME_FORMAT_STRING}`), q(I, "FILTER_TIMEOUT_MS", 700), q(I, "ERROR_TOAST_LIFE", 0), q(I, "MAX_FILE_UPLOAD_BYTES", 2e7), q(I, "BASE_CURRENCY", "EUR"), q(I, "RAM_UNIT", "GB"), q(I, "FREQUENCY_UNIT", "GHz"), q(I, "SELECT_OPTION_EMPTY", {
  value: null,
  text: "Select One"
});
function _o(t, e, n) {
  return t.sort((r, i) => so(r[e], i[e], n));
}
function so(t, e, n) {
  const r = l(t, l.ISO_8601, !0).isValid() && l(e, l.ISO_8601, !0).isValid() ? "date" : typeof t, i = n === "asc" ? r === "date" ? new Date(t) : t : r === "date" ? new Date(e) : e, s = n === "asc" ? r === "date" ? new Date(e) : e : r === "date" ? new Date(t) : t;
  switch (r) {
    case "number":
      return i - s;
    case "string":
    default:
      return i < s ? -1 : i > s ? 1 : 0;
  }
}
function yo(t, e) {
  const n = /* @__PURE__ */ new Map();
  return t.forEach((r) => {
    const i = e(r), s = n.get(i);
    s ? s.push(r) : n.set(i, [r]);
  }), n;
}
var ao = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, oo = { exports: {} };
/*!
 * clipboard.js v2.0.11
 * https://clipboardjs.com/
 *
 * Licensed MIT © Zeno Rocha
 */
(function(t, e) {
  (function(n, r) {
    t.exports = r();
  })(ao, function() {
    return (
      /******/
      function() {
        var n = {
          /***/
          686: (
            /***/
            function(s, a, o) {
              o.d(a, {
                default: function() {
                  return (
                    /* binding */
                    nr
                  );
                }
              });
              var c = o(279), h = /* @__PURE__ */ o.n(c), p = o(370), Y = /* @__PURE__ */ o.n(p), b = o(817), j = /* @__PURE__ */ o.n(b);
              function T(_) {
                try {
                  return document.execCommand(_);
                } catch {
                  return !1;
                }
              }
              var C = function(_) {
                var f = j()(_);
                return T("cut"), f;
              }, x = C;
              function K(_) {
                var f = document.documentElement.getAttribute("dir") === "rtl", g = document.createElement("textarea");
                g.style.fontSize = "12pt", g.style.border = "0", g.style.padding = "0", g.style.margin = "0", g.style.position = "absolute", g.style[f ? "right" : "left"] = "-9999px";
                var y = window.pageYOffset || document.documentElement.scrollTop;
                return g.style.top = "".concat(y, "px"), g.setAttribute("readonly", ""), g.value = _, g;
              }
              var ze = function(_, f) {
                var g = K(_);
                f.container.appendChild(g);
                var y = j()(g);
                return T("copy"), g.remove(), y;
              }, $n = function(_) {
                var f = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {
                  container: document.body
                }, g = "";
                return typeof _ == "string" ? g = ze(_, f) : _ instanceof HTMLInputElement && !["text", "search", "url", "tel", "password"].includes(_ == null ? void 0 : _.type) ? g = ze(_.value, f) : (g = j()(_), T("copy")), g;
              }, de = $n;
              function Ut(_) {
                "@babel/helpers - typeof";
                return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Ut = function(f) {
                  return typeof f;
                } : Ut = function(f) {
                  return f && typeof Symbol == "function" && f.constructor === Symbol && f !== Symbol.prototype ? "symbol" : typeof f;
                }, Ut(_);
              }
              var zn = function() {
                var _ = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, f = _.action, g = f === void 0 ? "copy" : f, y = _.container, D = _.target, A = _.text;
                if (g !== "copy" && g !== "cut")
                  throw new Error('Invalid "action" value, use either "copy" or "cut"');
                if (D !== void 0)
                  if (D && Ut(D) === "object" && D.nodeType === 1) {
                    if (g === "copy" && D.hasAttribute("disabled"))
                      throw new Error('Invalid "target" attribute. Please use "readonly" instead of "disabled" attribute');
                    if (g === "cut" && (D.hasAttribute("readonly") || D.hasAttribute("disabled")))
                      throw new Error(`Invalid "target" attribute. You can't cut text from elements with "readonly" or "disabled" attributes`);
                  } else
                    throw new Error('Invalid "target" value, use a valid Element');
                if (A)
                  return de(A, {
                    container: y
                  });
                if (D)
                  return g === "cut" ? x(D) : de(D, {
                    container: y
                  });
              }, Zn = zn;
              function Ot(_) {
                "@babel/helpers - typeof";
                return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? Ot = function(f) {
                  return typeof f;
                } : Ot = function(f) {
                  return f && typeof Symbol == "function" && f.constructor === Symbol && f !== Symbol.prototype ? "symbol" : typeof f;
                }, Ot(_);
              }
              function qn(_, f) {
                if (!(_ instanceof f))
                  throw new TypeError("Cannot call a class as a function");
              }
              function Ze(_, f) {
                for (var g = 0; g < f.length; g++) {
                  var y = f[g];
                  y.enumerable = y.enumerable || !1, y.configurable = !0, "value" in y && (y.writable = !0), Object.defineProperty(_, y.key, y);
                }
              }
              function Bn(_, f, g) {
                return f && Ze(_.prototype, f), g && Ze(_, g), _;
              }
              function Jn(_, f) {
                if (typeof f != "function" && f !== null)
                  throw new TypeError("Super expression must either be null or a function");
                _.prototype = Object.create(f && f.prototype, { constructor: { value: _, writable: !0, configurable: !0 } }), f && he(_, f);
              }
              function he(_, f) {
                return he = Object.setPrototypeOf || function(g, y) {
                  return g.__proto__ = y, g;
                }, he(_, f);
              }
              function Qn(_) {
                var f = tr();
                return function() {
                  var g = Ht(_), y;
                  if (f) {
                    var D = Ht(this).constructor;
                    y = Reflect.construct(g, arguments, D);
                  } else
                    y = g.apply(this, arguments);
                  return Xn(this, y);
                };
              }
              function Xn(_, f) {
                return f && (Ot(f) === "object" || typeof f == "function") ? f : Kn(_);
              }
              function Kn(_) {
                if (_ === void 0)
                  throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
                return _;
              }
              function tr() {
                if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
                  return !1;
                if (typeof Proxy == "function")
                  return !0;
                try {
                  return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
                  })), !0;
                } catch {
                  return !1;
                }
              }
              function Ht(_) {
                return Ht = Object.setPrototypeOf ? Object.getPrototypeOf : function(f) {
                  return f.__proto__ || Object.getPrototypeOf(f);
                }, Ht(_);
              }
              function fe(_, f) {
                var g = "data-clipboard-".concat(_);
                if (f.hasAttribute(g))
                  return f.getAttribute(g);
              }
              var er = /* @__PURE__ */ function(_) {
                Jn(g, _);
                var f = Qn(g);
                function g(y, D) {
                  var A;
                  return qn(this, g), A = f.call(this), A.resolveOptions(D), A.listenClick(y), A;
                }
                return Bn(g, [{
                  key: "resolveOptions",
                  value: function() {
                    var y = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
                    this.action = typeof y.action == "function" ? y.action : this.defaultAction, this.target = typeof y.target == "function" ? y.target : this.defaultTarget, this.text = typeof y.text == "function" ? y.text : this.defaultText, this.container = Ot(y.container) === "object" ? y.container : document.body;
                  }
                  /**
                   * Adds a click event listener to the passed trigger.
                   * @param {String|HTMLElement|HTMLCollection|NodeList} trigger
                   */
                }, {
                  key: "listenClick",
                  value: function(y) {
                    var D = this;
                    this.listener = Y()(y, "click", function(A) {
                      return D.onClick(A);
                    });
                  }
                  /**
                   * Defines a new `ClipboardAction` on each click event.
                   * @param {Event} e
                   */
                }, {
                  key: "onClick",
                  value: function(y) {
                    var D = y.delegateTarget || y.currentTarget, A = this.action(D) || "copy", It = Zn({
                      action: A,
                      container: this.container,
                      target: this.target(D),
                      text: this.text(D)
                    });
                    this.emit(It ? "success" : "error", {
                      action: A,
                      text: It,
                      trigger: D,
                      clearSelection: function() {
                        D && D.focus(), window.getSelection().removeAllRanges();
                      }
                    });
                  }
                  /**
                   * Default `action` lookup function.
                   * @param {Element} trigger
                   */
                }, {
                  key: "defaultAction",
                  value: function(y) {
                    return fe("action", y);
                  }
                  /**
                   * Default `target` lookup function.
                   * @param {Element} trigger
                   */
                }, {
                  key: "defaultTarget",
                  value: function(y) {
                    var D = fe("target", y);
                    if (D)
                      return document.querySelector(D);
                  }
                  /**
                   * Allow fire programmatically a copy action
                   * @param {String|HTMLElement} target
                   * @param {Object} options
                   * @returns Text copied.
                   */
                }, {
                  key: "defaultText",
                  /**
                   * Default `text` lookup function.
                   * @param {Element} trigger
                   */
                  value: function(y) {
                    return fe("text", y);
                  }
                  /**
                   * Destroy lifecycle.
                   */
                }, {
                  key: "destroy",
                  value: function() {
                    this.listener.destroy();
                  }
                }], [{
                  key: "copy",
                  value: function(y) {
                    var D = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {
                      container: document.body
                    };
                    return de(y, D);
                  }
                  /**
                   * Allow fire programmatically a cut action
                   * @param {String|HTMLElement} target
                   * @returns Text cutted.
                   */
                }, {
                  key: "cut",
                  value: function(y) {
                    return x(y);
                  }
                  /**
                   * Returns the support of the given action, or all actions if no action is
                   * given.
                   * @param {String} [action]
                   */
                }, {
                  key: "isSupported",
                  value: function() {
                    var y = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : ["copy", "cut"], D = typeof y == "string" ? [y] : y, A = !!document.queryCommandSupported;
                    return D.forEach(function(It) {
                      A = A && !!document.queryCommandSupported(It);
                    }), A;
                  }
                }]), g;
              }(h()), nr = er;
            }
          ),
          /***/
          828: (
            /***/
            function(s) {
              var a = 9;
              if (typeof Element < "u" && !Element.prototype.matches) {
                var o = Element.prototype;
                o.matches = o.matchesSelector || o.mozMatchesSelector || o.msMatchesSelector || o.oMatchesSelector || o.webkitMatchesSelector;
              }
              function c(h, p) {
                for (; h && h.nodeType !== a; ) {
                  if (typeof h.matches == "function" && h.matches(p))
                    return h;
                  h = h.parentNode;
                }
              }
              s.exports = c;
            }
          ),
          /***/
          438: (
            /***/
            function(s, a, o) {
              var c = o(828);
              function h(b, j, T, C, x) {
                var K = Y.apply(this, arguments);
                return b.addEventListener(T, K, x), {
                  destroy: function() {
                    b.removeEventListener(T, K, x);
                  }
                };
              }
              function p(b, j, T, C, x) {
                return typeof b.addEventListener == "function" ? h.apply(null, arguments) : typeof T == "function" ? h.bind(null, document).apply(null, arguments) : (typeof b == "string" && (b = document.querySelectorAll(b)), Array.prototype.map.call(b, function(K) {
                  return h(K, j, T, C, x);
                }));
              }
              function Y(b, j, T, C) {
                return function(x) {
                  x.delegateTarget = c(x.target, j), x.delegateTarget && C.call(b, x);
                };
              }
              s.exports = p;
            }
          ),
          /***/
          879: (
            /***/
            function(s, a) {
              a.node = function(o) {
                return o !== void 0 && o instanceof HTMLElement && o.nodeType === 1;
              }, a.nodeList = function(o) {
                var c = Object.prototype.toString.call(o);
                return o !== void 0 && (c === "[object NodeList]" || c === "[object HTMLCollection]") && "length" in o && (o.length === 0 || a.node(o[0]));
              }, a.string = function(o) {
                return typeof o == "string" || o instanceof String;
              }, a.fn = function(o) {
                var c = Object.prototype.toString.call(o);
                return c === "[object Function]";
              };
            }
          ),
          /***/
          370: (
            /***/
            function(s, a, o) {
              var c = o(879), h = o(438);
              function p(T, C, x) {
                if (!T && !C && !x)
                  throw new Error("Missing required arguments");
                if (!c.string(C))
                  throw new TypeError("Second argument must be a String");
                if (!c.fn(x))
                  throw new TypeError("Third argument must be a Function");
                if (c.node(T))
                  return Y(T, C, x);
                if (c.nodeList(T))
                  return b(T, C, x);
                if (c.string(T))
                  return j(T, C, x);
                throw new TypeError("First argument must be a String, HTMLElement, HTMLCollection, or NodeList");
              }
              function Y(T, C, x) {
                return T.addEventListener(C, x), {
                  destroy: function() {
                    T.removeEventListener(C, x);
                  }
                };
              }
              function b(T, C, x) {
                return Array.prototype.forEach.call(T, function(K) {
                  K.addEventListener(C, x);
                }), {
                  destroy: function() {
                    Array.prototype.forEach.call(T, function(K) {
                      K.removeEventListener(C, x);
                    });
                  }
                };
              }
              function j(T, C, x) {
                return h(document.body, T, C, x);
              }
              s.exports = p;
            }
          ),
          /***/
          817: (
            /***/
            function(s) {
              function a(o) {
                var c;
                if (o.nodeName === "SELECT")
                  o.focus(), c = o.value;
                else if (o.nodeName === "INPUT" || o.nodeName === "TEXTAREA") {
                  var h = o.hasAttribute("readonly");
                  h || o.setAttribute("readonly", ""), o.select(), o.setSelectionRange(0, o.value.length), h || o.removeAttribute("readonly"), c = o.value;
                } else {
                  o.hasAttribute("contenteditable") && o.focus();
                  var p = window.getSelection(), Y = document.createRange();
                  Y.selectNodeContents(o), p.removeAllRanges(), p.addRange(Y), c = p.toString();
                }
                return c;
              }
              s.exports = a;
            }
          ),
          /***/
          279: (
            /***/
            function(s) {
              function a() {
              }
              a.prototype = {
                on: function(o, c, h) {
                  var p = this.e || (this.e = {});
                  return (p[o] || (p[o] = [])).push({
                    fn: c,
                    ctx: h
                  }), this;
                },
                once: function(o, c, h) {
                  var p = this;
                  function Y() {
                    p.off(o, Y), c.apply(h, arguments);
                  }
                  return Y._ = c, this.on(o, Y, h);
                },
                emit: function(o) {
                  var c = [].slice.call(arguments, 1), h = ((this.e || (this.e = {}))[o] || []).slice(), p = 0, Y = h.length;
                  for (p; p < Y; p++)
                    h[p].fn.apply(h[p].ctx, c);
                  return this;
                },
                off: function(o, c) {
                  var h = this.e || (this.e = {}), p = h[o], Y = [];
                  if (p && c)
                    for (var b = 0, j = p.length; b < j; b++)
                      p[b].fn !== c && p[b].fn._ !== c && Y.push(p[b]);
                  return Y.length ? h[o] = Y : delete h[o], this;
                }
              }, s.exports = a, s.exports.TinyEmitter = a;
            }
          )
          /******/
        }, r = {};
        function i(s) {
          if (r[s])
            return r[s].exports;
          var a = r[s] = {
            /******/
            // no module.id needed
            /******/
            // no module.loaded needed
            /******/
            exports: {}
            /******/
          };
          return n[s](a, a.exports, i), a.exports;
        }
        return function() {
          i.n = function(s) {
            var a = s && s.__esModule ? (
              /******/
              function() {
                return s.default;
              }
            ) : (
              /******/
              function() {
                return s;
              }
            );
            return i.d(a, { a }), a;
          };
        }(), function() {
          i.d = function(s, a) {
            for (var o in a)
              i.o(a, o) && !i.o(s, o) && Object.defineProperty(s, o, { enumerable: !0, get: a[o] });
          };
        }(), function() {
          i.o = function(s, a) {
            return Object.prototype.hasOwnProperty.call(s, a);
          };
        }(), i(686);
      }().default
    );
  });
})(oo);
function go(t) {
  var e;
  if (!((e = t.response) != null && e.data))
    return {
      severity: pe.ERROR,
      summary: "Failure",
      detail: t.message || t.toString()
    };
  const n = t.response.data, r = n.code && n.message ? `${n.code}: ${n.message}` : `${t.response.status}: ${t.response.statusText}`, i = [];
  n.hint && i.push(`<b>Hint:</b> ${n.hint}`), n.details && i.push(`<b>Details:</b> ${n.details}`), t.response && i.push(`<b>Status:</b> ${t.response.status} - ${t.response.statusText}`);
  const s = i.join("<br/>");
  return {
    severity: pe.ERROR,
    // summary: `${error.response.status}:${error.response.statusText}`,
    summary: r,
    detail: s
    // life: 3000
  };
}
export {
  pe as E,
  go as L,
  ho as N,
  fo as R,
  co as _,
  _o as a,
  yo as r
};
